<div id="modal-onvif-profiles" class="jqmWindow">
    <div class="modal-head">
        <!-- template start -->
        <span>Сконфигурированные медиа-профили камеры модели <a href='$cameraUri' target='_blank'
                title='открыть веб-интерфейс камеры'>$cameraName</a></span>
        <!-- template end -->
        <a href="#" class="jqmClose">X</a>
    </div>
    <hr>
    <div class="modal-body">
        <ul class="onvif-profile-list">
            <!-- template start -->
            <li>
                <div>
                    <div class="left">
                        <p>Имя профиля: $name</p>

                        <p>Видео кодек: $videoEncoding $videoEncoderProfile $videoResolution $frameRateLimit
                            $videoBitRateLimit</p>

                        <p>Аудио кодек: $audio</p>
                    </div>
                    <div class="right"><input type="button" value="Выбрать" data-uri="{$name}"/></div>
                </div>
            </li>
            <!-- template end -->
        </ul>
    </div>
</div>

<div id="modal-profiles-loading" class="jqmWindow">
    <div class="modal-body">
        <p>Загружаем профили..</p>
    </div>
</div>

<script type="text/javascript">
    window.onvifProfiles = new (function ($container) {
        var profilesList = $container.find('.onvif-profile-list'),
            tplProfileEntry = profilesList.html(),
            tplTitle = $container.find('.modal-head span').html(),
            __onProfileSelect = null,
            $modalLoading = $("#modal-profiles-loading");

        $container.jqm();
        $modalLoading.jqm({
            modal: true
        });

        /**
         * @param {Object} data
         * @param data.InetCam_IP
         * @param data.InetCam_PASSWD
         * @param data.InetCam_USER
         * @param data.onvif_http_port
         */
        this.setConnectionInfo = function (data) {
            this.connectionInfo = data || {};
        };

        this.getConnectionInfo = function () {
            return this.connectionInfo;
        }

        /**
         * @param {Boolean} showLoadingState
         * @returns {*}
         */
        this.connect = function (showLoadingState) {
            var self = this,
                connectionInfo = this.getConnectionInfo(),
                postData = {
                    cameraNumber: cam_tune_info['cam_nr'],
                    host: connectionInfo['InetCam_IP'],
                    port: connectionInfo['onvif_http_port'],
                    username: connectionInfo['InetCam_USER'],
                    password: connectionInfo['InetCam_PASSWD']
                };

            var jqxhrGetDeviceInfo = $.ajax({
                type: "POST",
                url: WwwPrefix + '/lib/OnvifClientController.php',
                data: {
                    method: 'getDeviceInfo',
                    data: postData
                },
                dataType: 'json'
            });


            var jqxhrGetProfiles = $.ajax({
                type: "POST",
                url: WwwPrefix + '/lib/OnvifClientController.php',
                data: {
                    method: 'getProfiles',
                    data: postData
                },
                dataType: 'json'
            });

            if (showLoadingState) {
                $modalLoading.jqmShow();
            }

            $.when(jqxhrGetDeviceInfo, jqxhrGetProfiles)
                .done(function (responseDeviceInfo, responseGetProfiles) {
                    var deviceInfo = responseDeviceInfo[0]
                        , profiles = responseGetProfiles[0]['Profiles']['Profiles']
                        , getProfileTasks = []
                        , i
                        , I;
                    for (i = 0, I = profiles.length; i < I; i += 1) {
                        var profile = profiles[i]
                            , profileToken = profile['token'];
                        if (!profile['VideoEncoderConfiguration']) {
                            var newPostData = {};
                            $.extend(newPostData, { "ProfileToken": profileToken }, postData );
                            getProfileTasks.push(
                                $.ajax({
                                    type: "POST",
                                    url: WwwPrefix + '/lib/OnvifClientController.php',
                                    data: {
                                        method: 'getProfile',
                                        data: newPostData
                                    },
                                    dataType: 'json'
                                })
                            );
                        } else {
                            getProfileTasks.push(
                                $.Deferred().resolve(profile)
                            );
                        }
                    }

                    $.when.apply($, getProfileTasks)
                        .done(function () {
                            var profiles_ = [];

                            for (var a = 0, A = arguments.length; a < A; a += 1) {
                                var r = arguments[a]
                                    , profile_;
                                profile_ = Array.isArray(r) ? r[0]['Profile']['Profile'] : r;
                                profiles_.push(profile_);
                            }
                            self.renderTitle(deviceInfo);
                            self.renderProfiles(profiles_);
                        })
                        .always(function() {
                            $modalLoading.jqmHide();
                        });
                })
                .fail(function () {
                    $modalLoading.jqmHide();
                });

            return jqxhrGetProfiles;
        }

        this.renderProfiles = function (profiles) {
            profilesList.empty();

            for (var i = 0, I = profiles.length; i < I; i++) {
                var profile = profiles[i],
                    profileName,
                    tokenName,
                    videoEncoderProfile,
                    videoCodec,
                    audioCodec, 
                    frameRateLimit,
                    videoBitRate,
                    resolution,
                    audioBitrate,
                    vEncConf;

                profileName = profile['Name'];
                tokenName = profile['token'];
                videoEncoderProfile = '';

                if (typeof(profile['VideoSourceConfiguration']) !== 'undefined' &&
                    typeof(profile['VideoEncoderConfiguration']) !== 'undefined') {
                    videoCodec = profile['VideoEncoderConfiguration']['Encoding'];
                    if (typeof profile['VideoEncoderConfiguration']['RateControl'] !== 'undefined') {
                        frameRateLimit = profile['VideoEncoderConfiguration']['RateControl']['FrameRateLimit'] + 'fps';
                        videoBitRate = profile['VideoEncoderConfiguration']['RateControl']['BitrateLimit'] + 'kbps';
                    }
                    if (typeof profile['VideoEncoderConfiguration']['Resolution'] !== 'undefined') {
                        resolution = profile['VideoEncoderConfiguration']['Resolution']['Width'] + 'x' +
                            profile['VideoEncoderConfiguration']['Resolution']['Height'] + 'px';
                    }
                    if (typeof(profile['VideoEncoderConfiguration']['H264']) !== 'undefined') {
                        vEncConf = profile['VideoEncoderConfiguration']['H264'];
                        if (typeof(vEncConf['H264Profile']) !== 'undefined') {
                            videoEncoderProfile = vEncConf['H264Profile'];
                        }
                    } else if (typeof(profile['VideoEncoderConfiguration']['MPEG4']) !== 'undefined') {
                        vEncConf = profile['VideoEncoderConfiguration']['MPEG4'];
                        if (typeof(vEncConf['Mpeg4Profile']) !== 'undefined') {
                            videoEncoderProfile = vEncConf['Mpeg4Profile'];
                        }
                    }
                }
                if (typeof(profile['AudioSourceConfiguration']) !== 'undefined' &&
                    typeof(profile['AudioEncoderConfiguration']) !== 'undefined') {
                    audioCodec = profile['AudioEncoderConfiguration']['Encoding'];
                    audioBitrate = profile['AudioEncoderConfiguration']['Bitrate'] + 'kbps';
                }

                var $tplEntry = $(
                    tplProfileEntry
                        .replace('$name', profileName + ' (' + tokenName + ')')
                        .replace('$videoEncoding', videoCodec)
                        .replace('$videoEncoderProfile', videoEncoderProfile)
                        .replace('$frameRateLimit', frameRateLimit)
                        .replace('$videoBitRateLimit', videoBitRate)
                        .replace('$videoResolution', resolution)
                        .replace('$audio', profile['AudioEncoderConfiguration'] ?
                            (audioCodec + ' ' + audioBitrate)
                            : 'отсутствует')
                );

                $tplEntry.data('profile', profile);

                profilesList.append($tplEntry)
            }
        }

        this.renderTitle = function(deviceInfo) {
            var connectionInfo = this.getConnectionInfo();

            $container
                .find('.modal-head span')
                .empty()
                .html(tplTitle
                    .replace('$cameraName', deviceInfo['DeviceInformation']['Model'])
                    .replace('$cameraUri', 'http://' + connectionInfo['InetCam_IP'] + ':' + connectionInfo['onvif_http_port'])
                )
        }

        profilesList.on('click', 'input', function (e) {
            __onProfileSelect($(this).parents('li').data('profile'));
        });

        /**
         * @param {Function} callback
         */
        this.onProfileSelect = function (callback) {
            __onProfileSelect = callback;
        }

        this.showUi = function () {
            $container.jqmShow();
        }
        this.hideUi = function () {
            $container.jqmHide();
        }
    })($('#modal-onvif-profiles'));
</script>
<!-- /* vim: set expandtab smartindent tabstop=4 shiftwidth=4: */ -->
