<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 * @file admin/mon-addnew.php
 * @brief Создание новой раскладки
 */
if (isset($_POST['pipes_show'])) {
    $pipes_show = $_POST['pipes_show'];
}
if (isset($pipes_show)) {
    settype($pipes_show, 'int');
    setcookie('avreg_pipes_show', $pipes_show, time() + 5184000);
} else {
    if (isset($_COOKIE['avreg_pipes_show'])) {
        $pipes_show = (int)$_COOKIE['avreg_pipes_show'];
    } else {
        $pipes_show = 1;
    }
}

if (empty($_COOKIE['layouts-filter'])) {
    $layoutsFilter = '0-10';
} else {
    $layoutsFilter = $_COOKIE['layouts-filter'];
}

$lang_file = '_online.php';
$link_javascripts = array(
    'admin/js/layout-helpers.js',
    'lib/js/third-party/jquery.cookie.js'
);
$css_links = array(
    'admin/admin.css'
);
$USE_JQUERY = true;
require('../head.inc.php');

DENY($admin_status);

require('./mon-type.inc.php');
require_once '../lib/html-inputs-helper.php';

?>

<script type="text/javascript">
    var layoutsFilter = "<?php echo $layoutsFilter; ?>";

    function reset_to_list() {
        window.open('<?php echo $conf['prefix']; ?>/admin/mon-list.php', target = '_self');
    }
</script>

<?php
echo '<h1>' . sprintf($r_mons, $named, $sip) . '</h1>' . "\n";

if (!isset($mon_nr) || $mon_nr === '' || empty($display)) {
    die('empty $mon_nr and/or $display');
}

if (!settype($mon_nr, 'int')) {
    die('$mon_nr is\'t integer value');
}

if ($mon_nr < 0 || $mon_nr > 9) {
    die('$mon_nr in\'t in [0..9]');
}

if (!($display == 'L' || $display == 'R')) {
    die('$display must be L or R char');
}

if (isset($cmd)) {
    if (empty($mon_type)) {
        print '<p class="HiLiteBigErr">' . $strMonAddErr1 . '</p>' . "\n";
        print_go_back();
        require('../foot.inc.php');
        exit;
    }
    $layout_def = $layouts_defs[$mon_type];
    if (empty($layout_def)) {
        print '<p class="HiLiteBigErr">' . $strMonAddErr1 . '</p>' . "\n";
        print_go_back();
        require('../foot.inc.php');
        exit;
    }

    if (empty($mon_name)) {
        $mon_name = $mon_type;
    }
    switch ($cmd) {
        case '_ADD_NEW_MON_':
            require('active_pipe.inc.php');
            $wins_array = &$active_pipes;
            if (count($wins_array) > 0) {
                print '<p class="HiLiteBigWarn">' . sprintf(
                    $fmtMonAddInfo,
                    $mon_type,
                    $mon_nr,
                    @empty($mon_name) ? 'no name' : $mon_name,
                    $display == 'R' ? $sRightDisplay1 : $sLeftDisplay1
                ) . '</p>' . "\n";
                print '<p class="HiLiteBigWarn">' . $strMonAddInfo2 . '</p>' . "\n";
                $a = getSelectHtmlByName('mon_wins[]', $wins_array, false, 1, 1, '', true, 'camWindowSelectChanging(this);');
                //print('<pre><code>');print_r($a);print('</code></pre>');
                print '<form action="' . $_SERVER['PHP_SELF'] . '" onSubmit="return validateLayout(\'mon_wins[]\');" method="POST">'
                    . "\n";
                print $strNamed . ': <input type="text" name="mon_name" size=16 maxlength=16 value="' . $mon_name . "\"><br><br>\n";
                layout2table(
                    $mon_type,
                    null,
                    array(
                        'max-width' => $layout_def[2] > 4 ? 500 : 400,
                        'win-text' => $a
                    )
                );
                print '<input type="hidden" name="cmd" value="_ADD_NEW_MON_OK_">' . "\n";
                print '<input type="hidden" name="mon_nr" value="' . $mon_nr . '">' . "\n";
                print '<input type="hidden" name="display" value="' . $display . '">' . "\n";
                print '<input type="hidden" name="mon_type" value="' . $mon_type . '">' . "\n";
                print '<br><input type="submit" name="btn" value="' . $strSave . '">' . "\n";
                print '<input type="reset" name="btn" value="' . $strRevoke . '" onclick="reset_to_list();">' . "\n";
                print '</form>' . "\n";
            }
            require('../foot.inc.php');
            exit;
            break; /**/
        case '_ADD_NEW_MON_OK_':
            $i = 0;
            $fWINS = array();
            $vWINS = array();
            while ($i < count($mon_wins)) {
                if (!empty($mon_wins[$i])) {
                    array_push($fWINS, 'WIN' . ($i + 1));
                    array_push($vWINS, $mon_wins[$i]);
                }
                $i++;
            }
            if (count($fWINS) > 0) {
                $adb->addLayouts($display, $mon_nr, $mon_type, $mon_name, $remote_addr, $login_user, $fWINS, $vWINS);
                print "Ok!\n'";
                print '<script type="text/javascript" language="javascript">reset_to_list();</script>' . "\n";
            } else {
                print '<p class="HiLiteBigErr">' . $strNotChoiceCam . '</p>' . "\n";
                print_go_back();
                require('../foot.inc.php');
                exit;
            }
            break;
    } // switch
} else {
    echo '<h2>' . sprintf($r_mon_addnew, $mon_nr, $display == 'R' ? $sRightDisplay1 : $sLeftDisplay1) . '</h2>' . "\n";
    echo '<span>', 'Камер на раскладку', ': ',
    getSelectHtmlByName(
        'layoutsFilter',
        getLayoutRanges(MAX_CAMS_INTO_LAYOUT_MON),
        false,
        1,
        0,
        $layoutsFilter,
        false,
        'updateLayoutsByRange();'
    ),
    '<span>', PHP_EOL;
    //echo '</form>', PHP_EOL;

    $wins = range(1, MAX_CAMS_INTO_LAYOUT_WEB);

    print_go_back();

    echo '<div class="layouts-list">', PHP_EOL;
    foreach ($layouts_defs as $lname => &$ldef) {
        if ($ldef[0] > MAX_CAMS_INTO_LAYOUT_MON) {
            continue;
        }

        echo '<div class="layout-item" data-layout-type="', $lname,
        '" data-layout-wins-max="', $ldef[0], '">',
        PHP_EOL;
        printf(
            '<a href="%s?cmd=_ADD_NEW_MON_&mon_nr=%d&display=%s&mon_type=%s">%s</a>',
            $_SERVER['PHP_SELF'],
            $mon_nr,
            $display,
            $lname,
            $ldef[5]
        );
        layout2table($lname, $wins);
        echo '</div>', PHP_EOL;
    }
    echo '</div>', PHP_EOL;
    print_go_back();
}


require '../foot.inc.php';
