<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 *
 * @file admin/mon-type.inc.php
 * @brief Параметры раскладок
 *
 * Содержит базовые вариатны раскладок камер и функцию для построения раскладки
 *
 */
/*
 * array(0,1,1,1) - описывает ячейку
 * [0] - номер строки
 * [1] - номер колонки
 * [2] - объединяет ячеек по вертикали
 * [3] - объединяет ячеек по горизонтали
 */
const MAX_CAMS_INTO_LAYOUT_MON = 60;
const MAX_CAMS_INTO_LAYOUT_WEB = 120;

$multi_6_9_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 1, 1),
    array(1, 2, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
);
$multi_7_16_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 2, 2),
    array(2, 0, 2, 2),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
);

$multi_8_16_wins = array(
    array(0, 0, 3, 3),
    array(0, 3, 1, 1),
    array(1, 3, 1, 1),
    array(2, 3, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
);
$multi_10_16_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 2, 2),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
);
$multi_13_16_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 2, 2),
    array(1, 3, 1, 1),
    array(2, 0, 1, 1),
    array(2, 3, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
);
$multi_13_25_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 2, 2),
    array(0, 4, 1, 1),
    array(1, 4, 1, 1),
    array(2, 0, 2, 2),
    array(2, 2, 2, 2),
    array(2, 4, 1, 1),
    array(3, 4, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
);
$multi_16_25_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 2, 2),
    array(0, 4, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 4, 1, 1),
    array(2, 0, 2, 2),
    array(2, 2, 2, 2),
    array(2, 4, 1, 1),
    array(3, 4, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
);
$multi_17_25_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 3, 3),
    array(1, 4, 1, 1),
    array(2, 0, 1, 1),
    array(2, 4, 1, 1),
    array(3, 0, 1, 1),
    array(3, 4, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
);
$multi_19_25_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(1, 0, 2, 2),
    array(1, 2, 2, 2),
    array(1, 4, 1, 1),
    array(2, 4, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
);
$multi_22_25_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 2, 2),
    array(1, 3, 1, 1),
    array(1, 4, 1, 1),
    array(2, 0, 1, 1),
    array(2, 3, 1, 1),
    array(2, 4, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
);

$poly_2x3_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
);
$poly_3x4_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
);
$poly_2x4_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
    array(1, 3, 1, 1),
);
$poly_3x4_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
    array(1, 3, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
);

//-->Wide layouts

$wide_3_6_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 1, 1),
    array(1, 2, 1, 1),
);

$wide_6_6_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
);

$wide_9_15_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 2, 2),
    array(0, 4, 1, 1),
    array(1, 4, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(2, 4, 1, 1),
);

$wide_5_8_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(1, 2, 1, 1),
    array(1, 3, 1, 1),
);

$wide_12_24_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 2, 2),
    array(0, 3, 2, 2),
    array(0, 5, 1, 1),
    array(1, 0, 1, 1),
    array(1, 5, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 2, 2),
    array(2, 3, 2, 2),
    array(2, 5, 1, 1),
    array(3, 0, 1, 1),
    array(3, 5, 1, 1),
);

$wide_15_24_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(1, 0, 2, 2),
    array(1, 2, 2, 2),
    array(1, 4, 2, 2),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
);

$wide_18_24_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 2, 2),
    array(1, 3, 2, 2),
    array(1, 5, 1, 1),
    array(2, 0, 1, 1),
    array(2, 5, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
);

$wide_21_24_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 2, 2),
    array(1, 4, 1, 1),
    array(1, 5, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 4, 1, 1),
    array(2, 5, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
);

//ultra wide layouts

$wide_9_18_wins = array(
    array(0, 0, 2, 2),
    array(0, 2, 2, 2),
    array(0, 4, 2, 2),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(2, 4, 1, 1),
    array(2, 5, 1, 1),
);

$wide_12_18_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 2, 2),
    array(0, 3, 2, 2),
    array(0, 5, 1, 1),
    array(1, 0, 1, 1),
    array(1, 5, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(2, 4, 1, 1),
    array(2, 5, 1, 1),
);

$wide_15_18_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 2, 2),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 4, 1, 1),
    array(1, 5, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 1, 1),
    array(2, 4, 1, 1),
    array(2, 5, 1, 1),
);

$wide_28_40_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(1, 0, 2, 2),
    array(1, 2, 2, 2),
    array(1, 4, 2, 2),
    array(1, 6, 2, 2),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
    array(3, 6, 1, 1),
    array(3, 7, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
    array(4, 5, 1, 1),
    array(4, 6, 1, 1),
    array(4, 7, 1, 1)
);

$wide_34_40_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 2, 2),
    array(1, 4, 2, 2),
    array(1, 6, 1, 1),
    array(1, 7, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 6, 1, 1),
    array(2, 7, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
    array(3, 6, 1, 1),
    array(3, 7, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
    array(4, 5, 1, 1),
    array(4, 6, 1, 1),
    array(4, 7, 1, 1)
);

$wide_37_40_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 2, 2),
    array(1, 4, 1, 1),
    array(1, 5, 1, 1),
    array(1, 6, 1, 1),
    array(1, 7, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 4, 1, 1),
    array(2, 5, 1, 1),
    array(2, 6, 1, 1),
    array(2, 7, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 1, 1),
    array(3, 4, 1, 1),
    array(3, 5, 1, 1),
    array(3, 6, 1, 1),
    array(3, 7, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
    array(4, 5, 1, 1),
    array(4, 6, 1, 1),
    array(4, 7, 1, 1)
);

$wide_48_60_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(0, 8, 1, 1),
    array(0, 9, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
    array(1, 3, 2, 2),
    array(1, 5, 2, 2),
    array(1, 7, 1, 1),
    array(1, 8, 1, 1),
    array(1, 9, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 7, 1, 1),
    array(2, 8, 1, 1),
    array(2, 9, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 3, 2, 2),
    array(3, 5, 2, 2),
    array(3, 7, 1, 1),
    array(3, 8, 1, 1),
    array(3, 9, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 7, 1, 1),
    array(4, 8, 1, 1),
    array(4, 9, 1, 1),
    array(5, 0, 1, 1),
    array(5, 1, 1, 1),
    array(5, 2, 1, 1),
    array(5, 3, 1, 1),
    array(5, 4, 1, 1),
    array(5, 5, 1, 1),
    array(5, 6, 1, 1),
    array(5, 7, 1, 1),
    array(5, 8, 1, 1),
    array(5, 9, 1, 1)
);

$wide_54_60_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(0, 8, 1, 1),
    array(0, 9, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 1, 1),
    array(1, 3, 1, 1),
    array(1, 4, 1, 1),
    array(1, 5, 1, 1),
    array(1, 6, 1, 1),
    array(1, 7, 1, 1),
    array(1, 8, 1, 1),
    array(1, 9, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 2, 1, 1),
    array(2, 3, 2, 2),
    array(2, 5, 2, 2),
    array(2, 7, 1, 1),
    array(2, 8, 1, 1),
    array(2, 9, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 1, 1),
    array(3, 7, 1, 1),
    array(3, 8, 1, 1),
    array(3, 9, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 2, 1, 1),
    array(4, 3, 1, 1),
    array(4, 4, 1, 1),
    array(4, 5, 1, 1),
    array(4, 6, 1, 1),
    array(4, 7, 1, 1),
    array(4, 8, 1, 1),
    array(4, 9, 1, 1),
    array(5, 0, 1, 1),
    array(5, 1, 1, 1),
    array(5, 2, 1, 1),
    array(5, 3, 1, 1),
    array(5, 4, 1, 1),
    array(5, 5, 1, 1),
    array(5, 6, 1, 1),
    array(5, 7, 1, 1),
    array(5, 8, 1, 1),
    array(5, 9, 1, 1)
);

$wide_30_60_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(0, 8, 1, 1),
    array(0, 9, 1, 1),
    array(1, 0, 2, 2),
    array(1, 2, 2, 2),
    array(1, 4, 2, 2),
    array(1, 6, 2, 2),
    array(1, 8, 2, 2),
    array(3, 0, 2, 2),
    array(3, 2, 2, 2),
    array(3, 4, 2, 2),
    array(3, 6, 2, 2),
    array(3, 8, 2, 2),
    array(5, 0, 1, 1),
    array(5, 1, 1, 1),
    array(5, 2, 1, 1),
    array(5, 3, 1, 1),
    array(5, 4, 1, 1),
    array(5, 5, 1, 1),
    array(5, 6, 1, 1),
    array(5, 7, 1, 1),
    array(5, 8, 1, 1),
    array(5, 9, 1, 1)
);

$wide_42_60_wins = array(
    array(0, 0, 1, 1),
    array(0, 1, 1, 1),
    array(0, 2, 1, 1),
    array(0, 3, 1, 1),
    array(0, 4, 1, 1),
    array(0, 5, 1, 1),
    array(0, 6, 1, 1),
    array(0, 7, 1, 1),
    array(0, 8, 1, 1),
    array(0, 9, 1, 1),
    array(1, 0, 1, 1),
    array(1, 1, 1, 1),
    array(1, 2, 2, 2),
    array(1, 4, 2, 2),
    array(1, 6, 2, 2),
    array(1, 8, 1, 1),
    array(1, 9, 1, 1),
    array(2, 0, 1, 1),
    array(2, 1, 1, 1),
    array(2, 8, 1, 1),
    array(2, 9, 1, 1),
    array(3, 0, 1, 1),
    array(3, 1, 1, 1),
    array(3, 2, 2, 2),
    array(3, 4, 2, 2),
    array(3, 6, 2, 2),
    array(3, 8, 1, 1),
    array(3, 9, 1, 1),
    array(4, 0, 1, 1),
    array(4, 1, 1, 1),
    array(4, 8, 1, 1),
    array(4, 9, 1, 1),
    array(5, 0, 1, 1),
    array(5, 1, 1, 1),
    array(5, 2, 1, 1),
    array(5, 3, 1, 1),
    array(5, 4, 1, 1),
    array(5, 5, 1, 1),
    array(5, 6, 1, 1),
    array(5, 7, 1, 1),
    array(5, 8, 1, 1),
    array(5, 9, 1, 1)
);

//-->

/// Список допустимы раскладок
/*
 * 'layout's type name' => array()
 * [0] - кол-во действительных ячеек в раскладке
 * [1] - колво столбцов матрицы раскладки
 * [2] - колво строк матрицы раскладки
 * [3] - описание каждой ячейки в раскладке
 * [4] - главная ячейка
 * [5] - название: "кол-во камер"
 */
$layouts_defs = array(
    'ONECAM'      => array(  1, 1,  1, null,                1, &$strONECAM),
    'WIDE_2_2'    => array(  2, 1,  2, null,                1, &$strWide_2_2),
    'WIDE_3_6'    => array(  3, 2,  3, &$wide_3_6_wins,     1, &$strWide_3_6),
    'QUAD_4_4'    => array(  4, 2,  2, null,                1, &$strQUAD_4_4),
    'WIDE_5_8'    => array(  5, 2,  4, &$wide_5_8_wins,     1, &$strWide_5_8),
    'MULTI_6_9'   => array(  6, 3,  3, &$multi_6_9_wins,    1, &$strMULTI_6_9),
    'WIDE_6_6'    => array(  6, 2,  3, &$wide_6_6_wins,     2, &$strWide_6_6),
    'MULTI_7_16'  => array(  7, 4,  4, &$multi_7_16_wins,   1, &$strMULTI_7_16),
    'MULTI_8_16'  => array(  8, 4,  4, &$multi_8_16_wins,   1, &$strMULTI_8_16),
    'QUAD_9_9'    => array(  9, 3,  3, null,                5, &$strQUAD_9_9),
    'WIDE_9_15'   => array(  9, 3,  5, &$wide_9_15_wins,    2, &$strWide_9_15),
    'WIDE_9_18'   => array(  9, 3,  6, &$wide_9_18_wins,    2, &$strWide_9_18),
    'MULTI_10_16' => array( 10, 4,  4, &$multi_10_16_wins,  1, &$strMULTI_10_16),
    'POLY_4_3'    => array( 12, 3,  4, null,                6, &$strPoly_4_3),
    'WIDE_12_24'  => array( 12, 4,  6, &$wide_12_24_wins,   2, &$strWide_12_24),
    'WIDE_12_18'  => array( 12, 3,  6, &$wide_12_18_wins,   2, &$strWide_12_18),
    'MULTI_13_16' => array( 13, 4,  4, &$multi_13_16_wins,  6, &$strMULTI_13_16),
    'MULTI_13_25' => array( 13, 5,  5, &$multi_13_25_wins,  6, &$strMULTI_13_25),
    'WIDE_15_15'  => array( 15, 3,  5, null,                8, &$strWide_15_15),
    'WIDE_15_24'  => array( 15, 4,  6, &$wide_15_24_wins,   8, &$strWide_15_24),
    'WIDE_15_18'  => array( 15, 3,  6, &$wide_15_18_wins,   3, &$strWide_15_18),
    'QUAD_16_16'  => array( 16, 4,  4, null,                6, &$strQUAD_16_16),
    'MULTI_16_25' => array( 16, 5,  5, &$multi_16_25_wins,  9, &$strMULTI_16_25),
    'MULTI_17_25' => array( 17, 5,  5, &$multi_17_25_wins,  7, &$strMULTI_17_25),
    'WIDE_18_24'  => array( 18, 4,  6, &$wide_18_24_wins,   9, &$strWide_18_24),
    'WIDE_18_18'  => array( 18, 3,  6, null,                9, &$strWide_18_18),
    'MULTI_19_25' => array( 19, 5,  5, &$multi_19_25_wins,  7, &$strMULTI_19_25),
    'POLY_5_4'    => array( 20, 4,  5, null,                8, &$strPoly_5_4),
    'WIDE_21_24'  => array( 21, 4,  6, &$wide_21_24_wins,   9, &$strWide_21_24),
    'MULTI_22_25' => array( 22, 5,  5, &$multi_22_25_wins,  7, &$strMULTI_22_25),
    'WIDE_24_24'  => array( 24, 4,  6, null,                9, &$strWide_24_24),
    'QUAD_25_25'  => array( 25, 5,  5, null,               13, &$strQUAD_25_25),
    'WIDE_28_28'  => array( 28, 4,  7, null,               11, &$strWide_28_28),
    'WIDE_28_40'  => array( 28, 5,  8, &$wide_28_40_wins,  10, &$strWide_28_40),
    'MULTI_30_30' => array( 30, 5,  6, null,               15, &$strMULTI_30_30),
    'WIDE_30_60'  => array( 30, 6, 10, &$wide_30_60_wins,  13, &$strWide_30_60),
    'WIDE_34_40'  => array( 34, 5,  8, &$wide_34_40_wins,  11, &$strWide_34_40),
    'WIDE_37_40'  => array( 37, 5,  8, &$wide_37_40_wins,  11, &$strWide_37_40),
    'WIDE_40_40'  => array( 40, 5,  8, null,               20, &$strWide_40_40),
    'POLY_7_6'    => array( 42, 6,  7, null,               18, &$strPoly_7_6),
    'WIDE_42_60'  => array( 42, 6, 10, &$wide_42_60_wins,  14, &$strWide_42_60),
    'WIDE_48_48'  => array( 48, 6,  8, null,               20, &$strWide_48_60),
    'WIDE_48_60'  => array( 48, 6, 10, &$wide_48_60_wins,  14, &$strWide_48_60),
    'WIDE_54_60'  => array( 54, 6, 10, &$wide_54_60_wins,  24, &$strWide_54_60),
    'WIDE_60_60'  => array( 60, 6, 10, null,               25, &$strWide_60_60),
    'POLY_10_7'   => array( 70, 7, 10, null,                1, '70 камер (10x7)'),
    'POLY_10_8'   => array( 80, 8, 10, null,                1, '80 камер (10x8)'),
    'POLY_14_7'   => array( 98, 7, 14, null,                1, '98 камер (14x7)'),
    'POLY_14_8'   => array(112, 8, 14, null,                1, '112 камер (14x8)'),
    'POLY_15_8'   => array(120, 8, 15, null,                1, '120 камер (15x8)')
);

function getLayoutRanges(int $maxWins)
{
    $step = 10;
    $ret = [];
    for ($i = 0; $i < $maxWins; $i += $step) {
        if ($step !== 20 && $i >= 40) {
            $step = 20;
        }
        $ret[] = sprintf('%d-%d', $i, $i + $step);
    }
    return $ret;
}

/***
 *
 *
 */
function getLayoutWinsStruct(string $layout_type, array $layout_defs)
{
    if (!empty($layout_defs[3])) {
        return $layout_defs[3];
    }

    $wins = array();
    for ($row = 0; $row < $layout_defs[1]; $row += 1) {
        for ($col = 0; $col < $layout_defs[2]; $col += 1) {
            array_push($wins, array($row, $col, 1, 1));
        }
    }
    return $wins;
}

/**
 *
 * Функция строит таблицу определенной раскладки
 * @param string $mon_type тип раскладки
 * @param array $win_text_array
 * @param array $options Array of options
 *    $options = [
 *       'max-width' => (int) максимальная ширина раскладки
 *       'win_text'  => (string)
 *    ]
 */
function layout2table(string $mon_type, array $win_text_array = null, array $options = null)
{
    $default_options = array(
        'max-width' => 160,
        'win-text' => ''
    );
    if (!is_array($options)) {
        $options = &$default_options;
    } else {
        $options = array_merge($default_options, $options);
    }
    //	 print "<pre>".var_dump($win_text_array)."</pre>";
    if (!array_key_exists($mon_type, $GLOBALS['layouts_defs'])) {
        echo '<p style="color:', $GLOBALS['error_color'], ';">Not defined layout type. Asc to developers.</p>', PHP_EOL;
        return;
    }

    $l_defs = &$GLOBALS['layouts_defs'][$mon_type];

    $bgcol = '#000099';

    if ($l_defs[0] >= 100) {
        $options['max-width'] *= 3;
    } else if ($l_defs[0] >= 60) {
        $options['max-width'] *= 2;
    }
    // error_log("$mon_type " . $options['max-width']);

    $k = (int)floor($options['max-width'] >> 2);
    $win = $k << 2;
    $h = $k * 3;
    $w2 = (int)floor($win / 2);
    $h2 = (int)floor($h / 2);
    $w3 = (int)floor($win / 3);
    $h3 = (int)floor($h / 3);
    $w4 = (int)floor($win / 4);
    $h4 = (int)floor($h / 4);
    $w5 = (int)floor($win / 5);
    $h5 = (int)floor($h / 5);

    if (preg_match('/WIDE_/', $mon_type) === 1) {
        $tbl_start = '<table cellspacing="0" border="0" cellpadding="0" style="height:90px; " >' . "\n";
    } else {
        $tbl_start = '<table cellspacing="0" border="0" cellpadding="0" style="height:120px; " >' . "\n";
    }

    $tbl_end = '</table>' . "\n";
    $r_start = '<tr>' . "\n";
    $r_end = '</tr>' . "\n";

    if (empty($options['max-width'])) {
        $t_start_1 = '<td align="center" valign="middle" bgcolor="' . $bgcol . '"><font color="white"><b>&nbsp;';
        $t_start_2 = &$t_start_1;
        $t_start_3 = &$t_start_1;
        $t_start_4 = &$t_start_1;
        $t_start_5 = &$t_start_1;
    } else {
        $t_start_1 = '<td width="' . $win . '" height="' . $h . '" align="center" valign="middle" bgcolor="' . $bgcol
            . '"><font color="white"><b>&nbsp;';
        $t_start_2 = '<td width="' . $w2 . '" height="' . $h2 . '" align="center" valign="middle" bgcolor="' . $bgcol
            . '"><font color="white"><b>&nbsp;';
        $t_start_3 = '<td width="' . $w3 . '" height="' . $h3 . '" align="center" valign="middle" bgcolor="' . $bgcol
            . '"><font color="white"><b>&nbsp;';
        $t_start_4 = '<td width="' . $w4 . '" height="' . $h4 . '" align="center" valign="middle" bgcolor="' . $bgcol
            . '"><font color="white"><b>&nbsp;';
        $t_start_5 = '<td width="' . $w5 . '" height="' . $h5 . '" align="center" valign="middle" bgcolor="' . $bgcol
            . '"><font color="white"><b>&nbsp;';
    }

    // $options['max-width'] / $wins_in_layout = $l_defs[0];
    $rows = $l_defs[1];
    $cols = $l_defs[2];
    $wins = getLayoutWinsStruct($mon_type, $l_defs);
    $major_win = $l_defs[4] - 1;

    $w1 = $options['max-width'] / $cols - 4 /* 2xborder */;
    $h1 = $w1 * 3 / 4;
    $count_camers_in_layout = count($wins);
    print $tbl_start;
    for ($win = 0; $win < $count_camers_in_layout; $win++) {
        $text_in_win = (!isset($options['win-text']) || @empty($options['win-text'])) ? @$win_text_array[$win] : $options['win-text'];
        if (!isset($options['win-text']) || @empty($text_in_win)) {
            $text_in_win = '&nbsp;';
        }
        list($row, $col, $rowspan, $colspan) = $wins[$win];
        if ($col === 0) {
            print $r_start;
            $max_rowspan = 1;
            $min_rowspan = 999;
        }
        if ($rowspan > $max_rowspan) {
            $max_rowspan = $rowspan;
        }
        if ($rowspan < $min_rowspan) {
            $min_rowspan = $rowspan;
        }

        $sz = sprintf('width=%d height=%d', $w1 * $colspan, $h1 * $rowspan);
        $e = ($win == $major_win) ? 'th' : 'td';
        if ($colspan > 1 || $rowspan > 1) {
            print "<$e $sz id=\"win_$win\" class=\"layout\" colspan=\"$colspan\" rowspan=\"$rowspan\"
            align=\"center\" valign=\"middle\">$text_in_win</$e>\n";
        } else {
            print "<$e $sz id=\"win_$win\" class=\"layout\" align=\"center\" valign=\"middle\">$text_in_win</$e>\n";
        }

        if (($col + $colspan) >= $cols) {
            /* закрываем строку */
            print $r_end;
            if ($max_rowspan > 1 && $max_rowspan == $min_rowspan) {
                print $r_start . $r_end;
            }
        }
    }
    print $tbl_end;
}
/* vim: set expandtab smartindent tabstop=4 shiftwidth=4: */
