<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 * @file admin/web_mon_addnew.php
 * @brief Создание новой раскладки для WEB
 */
if (isset($_POST['pipes_show'])) {
    $pipes_show = $_POST['pipes_show'];
}
if (isset($pipes_show)) {
    settype($pipes_show, 'int');
    setcookie('avreg_pipes_show', $pipes_show, time() + 5184000);
} else {
    if (isset($_COOKIE['avreg_pipes_show'])) {
        $pipes_show = (int)$_COOKIE['avreg_pipes_show'];
    } else {
        $pipes_show = 1;
    }
}

if (empty($_COOKIE['layouts-filter'])) {
    $layoutsFilter = '0-10';
} else {
    $layoutsFilter = $_COOKIE['layouts-filter'];
}

if (isset($pipes_show)) {
    settype($pipes_show, 'int');
    setcookie('avreg_pipes_show', $pipes_show, time() + 5184000);
} else {
    if (isset($_COOKIE['avreg_pipes_show'])) {
        $pipes_show = (int)$_COOKIE['avreg_pipes_show'];
    } else {
        $pipes_show = 1;
    }
}


$USE_JQUERY = true;

//определяем режим сохранения раскладки client(на клиенте)/server(на сервере)
$storage = 'server';
if (isset($_GET['storage'])) {
    $storage = $_GET['storage'];
} elseif (isset($_POST['storage'])) {
    $storage = $_POST['storage'];
}

$link_javascripts = array(
    'admin/js/layout-helpers.js'
);

if ($storage === 'client') {
    array_push(
        $link_javascripts,
        'lib/js/third-party/jquery.cookie.js',
        'lib/js/user_layouts.js',
        'lib/js/third-party/json2.js'
    );
} else {
    array_push(
        $link_javascripts,
        'lib/js/third-party/jquery.cookie.js'
    );
}

$css_links = array(
    'admin/admin.css'
);

$lang_file = '_online.php';
require('../head.inc.php');

//DENY($admin_status);
if ($storage != 'client') {
    DENY($admin_status);
}

require('./mon-type.inc.php');
require_once '../lib/html-inputs-helper.php';

?>

<script type="text/javascript">
    var layoutsFilter = "<?php echo $layoutsFilter; ?>";
    var user_login = "<?php echo $login_user; ?>";

    function reset_to_list() {
        window.open('<?php echo $conf['prefix']; ?>/admin/web_mon_list.php', target = '_self');
    }
</script>

<?php

echo '<h1>' . sprintf($web_r_mons, $named, $sip) . '</h1>' . "\n";

if (!isset($mon_nr) || $mon_nr == '') {
    die('empty $mon_nr');
}

if (!settype($mon_nr, 'int')) {
    die('$mon_nr is\'t integer value');
}

if ($mon_nr < 0) {
    die('Error: $mon_nr < 0');
}

if (isset($cmd)) {
    $layout_defs = &$layouts_defs[$mon_type];
    if (empty($layout_defs)) {
        print '<p class="HiLiteBigErr">' . $strMonAddErr1 . '</p>' . "\n";
        print_go_back();
        require('../foot.inc.php');
        exit;
    }

    $layout_def = $layouts_defs[$mon_type];
    if (empty($layout_def)) {
        print '<p class="HiLiteBigErr">' . $strMonAddErr1 . '</p>' . "\n";
        print_go_back();
        require('../foot.inc.php');
        exit;
    }

    if (empty($mon_name)) {
        $mon_name = $mon_type;
    }

    switch ($cmd) {
        case '_ADD_NEW_MON_':
            $MAX_WINS_INTO_CURRENT_LAYOUT = $layout_defs[0];
            require('web_active_pipe.inc.php');
            $wins_array = &$active_pipes;

            if (count($wins_array) > 0) {
                print '<p class="HiLiteBigWarn">' . sprintf(
                    $fmtWebMonAddInfo,
                    $mon_type,
                    $mon_nr,
                    $mon_name
                ) . '</p>' . "\n";
                print '<p class="HiLiteBigWarn">' . $strMonAddInfo2 . '</p>' . "\n";

                //формирование массива альтернативных источников видео
                $cams_srcs = array();
                foreach ($cams_params as $__cam_nr => $cam_detail) {
                    $cams_srcs[$__cam_nr] = array();
                    $cams_srcs[$__cam_nr]['avregd'] = true;
                    $cams_srcs[$__cam_nr]['alt_1'] = (!is_empty_var($cam_detail['cell_url_alt_1']['v']) ||
                        !is_empty_var($cam_detail['fs_url_alt_1']['v'])) ?
                        true : false;
                    $cams_srcs[$__cam_nr]['alt_2'] = (!is_empty_var($cam_detail['cell_url_alt_2']['v']) ||
                        !is_empty_var($cam_detail['fs_url_alt_2']['v'])) ?
                        true : false;
                }
                print '<script type="text/javascript">' . "\n";
                print 'var cams_alt =' . json_encode($cams_srcs) . ";\n";
                print '</script>' . "\n";

                //Создание эл-та селект ля ячеек раскладки
                $a = getSelectHtmlByName(
                    'mon_wins[]',
                    $wins_array,
                    false,
                    1,
                    1,
                    '',
                    true,
                    'camWindowSelectChanging(this); show_sub_select(this);',
                    '',
                    null,
                    $cams_srcs
                );

                if ($storage == 'client') { //Если раскладка создается на клиенте
                    print '<form action="../online/' . '" onSubmit="return user_layouts.add_new();"
					 method="POST">' . "\n";
                } else { //Если раскладка создается на сервере
                    print '<form action="' . $_SERVER['PHP_SELF'] . '"  onSubmit="return validateLayout(\'mon_wins[]\');" method="POST">'
                        . "\n";
                }

                print $strNamed . ': <input type="text" name="mon_name" size=16 maxlength=16 value="' . $mon_name . "\"><br><br>\n";
                layout2table($mon_type, null, array(
                    'max-width' => $layout_def[2] > 4 ? 500 : 400,
                    'win-text' => $a
                ));

                print '<input type="hidden" name="cmd" value="_ADD_NEW_MON_OK_">' . "\n";
                print '<input type="hidden" name="mon_nr" value="' . $mon_nr . 'UL' . '">' . "\n";
                print '<input type="hidden" name="mon_type" value="' . $mon_type . '">' . "\n";


                //Селектор сохранять пропорции/ на весь экран
                $AspectRatio = 'calc';
                print '<br /><div><span>' . $strAspectRatio . ":&nbsp;&nbsp;</span> \n";
                print '<span>' . getSelectByAssocAr(
                    'AspectRatio',
                    $AspectRatioArray,
                    false,
                    1,
                    1,
                    $AspectRatio,
                    false
                ) . "</span></div>\n";
                //Выводить имена камер
                $PrintCamNames = "checked";
                print '<br /><div><span>' . $strPrintCamNames . ":&nbsp;&nbsp;</span>\n";
                print '<span><input type="checkbox" name="PrintCamNames" ' . $PrintCamNames . ' />' . "</span></div>\n";

                //Установить интервал попыток переподключения к камере при отсутствии соединения
                $ReconnectTimeout = 5; //по умолчанию
                print '<br /><div><span>' . $strReconnectTimeout . ":&nbsp;&nbsp;</span> \n";
                print '<span>' . getSelectByAssocAr(
                    'ReconnectTimeout',
                    $ReconnectTimeoutArray,
                    false,
                    1,
                    1,
                    $ReconnectTimeout,
                    false
                ) . "</span></div>\n";

                print '<br /><div><span>' . $strStopHiddenCams . ":&nbsp;&nbsp;</span>\n";
                print "<span><input type='checkbox' name='StopHiddenCams' checked /></span></div>\n";

                //Кнопки сохранить раскладку и отменить
                print '<br><input type="submit" name="btn" value="' . $strSave . '">' . "\n";
                if ($storage == 'client') {
                    print '<input type="reset" name="btn" value="' . $strRevoke . '" onclick="user_layouts.redirect(\''
                        . $conf['prefix'] . '/admin/web_mon_list.php\', true);">' . "\n";
                } else {
                    print '<input type="reset" name="btn" value="' . $strRevoke . '" onclick="reset_to_list();">'
                        . "\n";
                }
                print '</form>' . "\n";
            }
            require('../foot.inc.php');
            exit;
            break; /**/
        case '_ADD_NEW_MON_OK_':
            $i = 0;
            $j = 0;

            $mwt = $_POST['mon_wins_type'];
            $allWINS = array();

            while ($i < count($mon_wins)) {
                if (!empty($mon_wins[$i])) {
                    //формирование единого объекта для всех ячеек раскладки
                    $allWINS[$i] = array();
                    array_push($allWINS[$i], $mon_wins[$i], $mwt[$j]);
                    $j++;
                }
                $i++;
            }

            $allWINS = json_encode($allWINS);

            if ($allWINS != '') {
                $PrintCamNames = ($PrintCamNames != null) ? 1 : 0;

                $adb->webAddLayouts(
                    $mon_nr,
                    $mon_type,
                    $mon_name,
                    $remote_addr,
                    $login_user,
                    $PrintCamNames,
                    $AspectRatio,
                    $ReconnectTimeout,
                    $StopHiddenCams,
                    $allWINS
                );

                print "Ok!\n'";
                print '<script type="text/javascript" language="javascript">reset_to_list();</script>' . "\n";
            } else {
                print '<p class="HiLiteBigErr">' . $strNotChoiceCam . '</p>' . "\n";
                print_go_back();
                require('../foot.inc.php');
                exit;
            }
            break;
    } // switch
} else {
    // без команды, просто выводим список типов раскладок
    echo '<h2>', sprintf($web_mon_addnew, $counter), '</h2>', PHP_EOL;
    //echo '<form method="POST" action="', $_SERVER['PHP_SELF'], '?', $_SERVER['QUERY_STRING'], '">', PHP_EOL;
    echo '<span>', 'Камер на раскладку', ': ',
    getSelectHtmlByName(
        'layoutsFilter',
        getLayoutRanges(MAX_CAMS_INTO_LAYOUT_WEB),
        false,
        1,
        0,
        $layoutsFilter,
        false,
        'updateLayoutsByRange();'
    ),
    '<span>', PHP_EOL;
    //echo '</form>', PHP_EOL;

    $wins = range(1, MAX_CAMS_INTO_LAYOUT_WEB);

    print_go_back();

    echo '<div class="layouts-list">', PHP_EOL;
    foreach ($layouts_defs as $lname => &$ldef) {
        if ($ldef[0] > MAX_CAMS_INTO_LAYOUT_WEB) {
            continue;
        }

        echo '<div class="layout-item" data-layout-type="', $lname,
        '" data-layout-wins-max="', $ldef[0], '">',
        PHP_EOL;
        printf(
            '<a href="%s?mon_nr=%s&storage=%s&mon_type=%s&cmd=_ADD_NEW_MON_">%s</a>',
            $_SERVER['PHP_SELF'],
            ($storage === 'client') ? $mon_nr . 'UL' : $mon_nr,
            $storage,
            $lname,
            $ldef[5]
        );
        layout2table($lname, $wins);
        echo '</div>', PHP_EOL;
    }
    echo '</div>', PHP_EOL;
    print_go_back();
}

require '../foot.inc.php';
/* vim: set expandtab smartindent tabstop=4 shiftwidth=4: */
