<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 *
 * @file head.inc.php
 * @brief В файле реализовано формирование базовой функциональности и структуры страниц сайта
 *
 */

ob_start();

require_once('lib/config.inc.php');

/**
 * Send http headers
 */
// Don't use cache (required for Opera)
$now = gmdate('D, d M Y H:i:s') . ' GMT';
header('Expires: ' . $now);
header('Last-Modified: ' . $now);
header('Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0'); // HTTP/1.1
header('Pragma: no-cache'); // HTTP/1.0
// Define the charset to be used
header('Content-Type: text/html; charset=' . $chset);
if (isset($ie6_quirks_mode) && $ie6_quirks_mode && preg_match('/MSIE\s*6/', $_SERVER['HTTP_USER_AGENT'])) {
    print '<?xml version="1.0" encoding="' . $chset . '"?>' . "\n";
}
print "<!DOCTYPE html>\n";
print "<html lang='$lang'><head>\n";
print '<meta http-equiv="Content-Type" content="text/html; charset=' . $chset . '" />' . "\n";
if (!@empty($IE_COMPAT)) {
    print '<meta http-equiv="X-UA-Compatible" content="' . $IE_COMPAT . '" />' . "\n";
}

print '<meta name="viewport" content="width=device-width, initial-scale=1.0">' . "\n";
print '<link rel="SHORTCUT ICON" href="' . $conf['prefix'] . '/favicon.ico">' . "\n";
print '<title>';
if (isset($GLOBALS['pageTitle'])) {
    if (isset($GLOBALS[$GLOBALS['pageTitle']])) {
        // use localized version onto lang file
        print($conf['server-name'] . '[' . $named . ']::' . $GLOBALS[$GLOBALS['pageTitle']]);
    } else {
        print($conf['server-name'] . '[' . $named . ']::' . $GLOBALS['pageTitle']);
    }
} else {
    print($conf['server-name'] . '[' . $named . ']');
}
print '</title>' . "\n";
if (isset($BaseTarget)) {
    print '<base target="' . $BaseTarget . '">' . "\n";
}

$__use_jquery = (isset($USE_JQUERY) && $USE_JQUERY);
$__use_bootstrap = (isset($USE_BOOTSTRAP) && $USE_BOOTSTRAP);
$__use_videojs = (isset($USE_VIDEOJS) && $USE_VIDEOJS);
$__use_icomoonfont = (isset($USE_ICOMOONFONT) && $USE_ICOMOONFONT);

if (!isset($DISABLE_MAIN_CSS)) {
    print '<style>' . "\n";
    // print '<!--'."\n";
    readfile($wwwdir . '/main.css');
    // print '// -->'."\n";
    print '</style>' . "\n";
}

$frameworks_css_ar = array();

if ($__use_bootstrap) {
    array_push($frameworks_css_ar, 'lib/css/third-party/bootstrap/bootstrap.min.css');
}

if ($__use_videojs) {
    array_push($frameworks_css_ar, 'lib/css/third-party/videojs/video-js.css');
    array_push($frameworks_css_ar, 'lib/css/third-party/videojs/videojs-startdate.css');
}

if ($__use_icomoonfont) {
    array_push($frameworks_css_ar, 'lib/css/third-party/icomoon/icomoon.css');
}

foreach ($frameworks_css_ar as &$__css_link_f) {
    print '<link rel="stylesheet" type="text/css" href="' . $conf['prefix'] . '/' . $__css_link_f . "\">\n";
}
?>

<!--[if lt IE 9]>
<script src="<?php echo $conf['prefix']; ?>/lib/js/third-party/html5shiv.js"></script>
<![endif]-->

<?php
if ($__use_videojs) {
?>
<!--[if IE]>
    <link rel="stylesheet" type="text/css"
        href="<?php echo $conf['prefix']; ?>/lib/css/third-party/videojs/videojs-override-ie.css" />
<![endif]-->
<!--[if !IE]><!-->
    <link rel="stylesheet" type="text/css"
        href="<?php echo $conf['prefix']; ?>/lib/css/third-party/videojs/videojs-override.css" />
 <!--<![endif]-->
<?php
}

if (isset($css_links) && is_array($css_links)) {
    foreach ($css_links as &$__css_link_f) {
        print '<link rel="stylesheet" type="text/css" href="' . $conf['prefix'] . '/' . $__css_link_f . "\">\n";
    }
}
?>
<script>
<?php
    /* setup PHP and JS global DEBUG variable */
    printf("    var DEBUG = %s;\n", @empty($_REQUEST['debug']) && @empty($conf['debug']) ? 'false' : 'true');
    printf("    var Lang  = '%s';\n", $lang);
    printf("    var OriginKey  = '%s';\n", trim($conf['prefix'], '/\t\n\r\0\x0B'));
    printf("    var WwwPrefix  = '%s';\n", addcslashes($conf['prefix'], '\'"/\\'));
    $request_json_obj = json_encode($_REQUEST, JSON_FORCE_OBJECT | JSON_NUMERIC_CHECK, 3);
    if ($request_json_obj === false) {
        error_log('json_last_error: ' . json_last_error());
        printf("    var REQUEST = {};\n");
    } else {
        printf("    var REQUEST = %s;\n", $request_json_obj);
    }

    $include_javascripts = array(
        'lib/js/header.inc.js',
        'lib/js/css3transform2d.inc.js',
        'lib/js/css4focus-within.inc.js',
        'lib/js/third-party/js.cookie.js'
    );

    foreach ($include_javascripts as &$__js) {
        if (preg_match('/\.php$/i', $__js)) {
            include $wwwdir.$__js; // todo  fix this - you don't want to include javascript files like this
        } else {
            readfile($wwwdir.$__js);
        }
    }
?>
</script>

<?php
    $common_link_javascripts = array();
if (!isset($link_javascripts) || !is_array($link_javascripts)) {
    $link_javascripts = array();
}
if ($__use_jquery) {
    $common_link_javascripts[] = 'lib/js/third-party/jquery.js';
    $common_link_javascripts[] = 'lib/js/third-party/jquery.browser.js';
    $common_link_javascripts[] = 'lib/js/jquery-helpers.js';
}
if ($__use_bootstrap) {
    $common_link_javascripts[] = 'lib/js/third-party/bootstrap/bootstrap.js';
}
if ($__use_videojs) {
    $common_link_javascripts[] = 'lib/js/third-party/videojs/video.js';
    $common_link_javascripts[] = "lib/js/third-party/videojs/lang/$lang.js";
    $common_link_javascripts[] = 'lib/js/third-party/videojs/videojs-startdate.js';
}

$all_link_js = array_merge($common_link_javascripts, $link_javascripts);
foreach ($all_link_js as &$__js_link) {
    print '<script src="' . $conf['prefix'] . '/' . $__js_link . '"></script>' . "\n";
}
?>
</head>

<?php

if (!isset($NOBODY)) {
    if (!isset($body_style)) {
        $body_style = '';
    }
    if (!isset($DISABLE_MAIN_CSS)) {
        if (isset($MENU)) {
            $pageBgColor = $left_bgcolor;
        } else {
            if (!isset($pageBgColor)) {
                $pageBgColor = $ContentColor;
            }
            // print_syslog(LOG_NOTICE, 'access: '.basename($_SERVER['SCRIPT_FILENAME']));
        }

        if (isset($pageBgColor) && !empty($pageBgColor)) {
            $body_style .= 'background-color: ' . $pageBgColor . ';';
        } else {
            $body_style .= 'visibility:visible;';
        }
    }

    if (isset($body_onload) && !empty($body_onload)) {
        $_onload = 'onload="' . $body_onload . '"';
    } elseif (isset($load) && !empty($load)) {
        $_onload = 'onload="window.open(\'' . $load . '\', target=\'content\')"';
    } else {
        $_onload = '';
    }

    if (!isset($body_addons)) {
        $body_addons = '';
    }

    print sprintf('<body style="%s" %s %s>', $body_style, $_onload, $body_addons) . "\n";
    $custom_header = preg_replace(
        '%^' . $conf['prefix'] . '(/.+)\.php$%',
        '\1_header.inc.php',
        $_SERVER['SCRIPT_NAME']
    );
    if (0 != strcmp($_SERVER['SCRIPT_NAME'], $custom_header)) {
        if ($conf['debug']) {
            print '<div class="legend header"><span class="legend">@include "' .
                $conf['customize-dir'] . $custom_header . "\"</span>\n";
        }
        #tohtml($_SERVER['SCRIPT_NAME']);
        @include($conf['customize-dir'] . $custom_header);
        if ($conf['debug']) {
            print "</div>\n";
        }
    }
}

?>
<noscript>
    <center>
        <div class="help" style="width:50%;text-align:left;">
            Ваш браузер не использует JavaScript.<br>
            Включите поддержку JavaScript и перегрузите/обновите эту страницу.
        </div>
    </center>
</noscript>
<div id="tooltip"></div>

<?php
// чтобы из включений customize/PAGE_header.inc.php можно было другой http-ответ послать, например redirect
if (empty($NO_OB_END_FLUSH)) {
    while (@ob_end_flush()) {
        // do nothing
    };
}

unset(
    $custom_header,
    $include_javascripts,
    $link_javascripts,
    $common_link_javascripts,
    $all_link_js,
    $css_links,
    $frameworks_css_ar,
    $__css_link_f,
    $request_json_obj
);

