<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 *
 * @file index.php
 * @brief генерация стартовой страницы сайта Avreg
 *
 * @mainpage AvregSite
 *
 * Веб-интерфейс
 *
 * Состоит из следующих частей:
 * - @ref lib
 * - @ref admin
 * - @ref lang
 * - @ref offline
 * - @ref online
 * - @ref pda
 *
 */

$NO_OB_END_FLUSH = true;

// $USE_SESSION = true;

$USE_JQUERY = true;

$css_links = array(
    'index.css'
);

$link_javascripts = array(
    'index.js',
    'lib/js/third-party/jquery.cookie.js',
    'lib/js/user_layouts.js',
    'lib/js/third-party/json2.js',
    'lib/js/third-party/modernizr.js'
);

require './head.inc.php';
while (@ob_end_flush()) {
    ;
}

function printCellular()
{
    print '<a class="main_links" href="./cellular/">' . "\n";
    print '<img src="./img/cellphone.png" width="48px" height="48px" border="0px" /></a>' . "\n";
    print '<p><a class="main_links" href="./cellular/">для<br>телефона</a></p>' . "\n";
}

function printOnline()
{
    global $a_webcam;
    print '<a class="main_links" onclick="online(\'./online/index.php\');" href="#" title="' . $a_webcam . '"><img
        src="./img/online.png" border="0"></a>' . "\n";
    print '<p><a class="main_links" onclick="online(\'' . './online/index.php\');" href="#">' . $a_webcam . '</a></p>' .
        "\n";
}

function printAdmin()
{
    global $conf, $sip, $named, $a_adminv;
    $href3 = sprintf($conf['prefix'] . '/admin/index.php?sip=%s&amp;named=%s', $sip, $named);
    print '<a class="main_links" href="' . $href3 . '" title="' . $a_adminv . '"><img   src="./img/admin.jpg"
        width="236" height="165" border="0"></a>' . "\n";
    print '<p align="center"><a class="main_links" href="' . $href3 . '">' . $a_adminv . '</a></p>' . "\n";
}

function printArchSearch()
{
    global $a_archive;
    print '<a class="main_links" href="./offline/search.php" title="' . $a_archive . '">
        <img   src="./img/offline-search.png"
        border="0"></a>' . "\n";
    print '<p><a class="main_links" href="./offline/search.php">' . $a_archive . '</a></p>' . "\n";
}

function printArchPlaylist()
{
    global $a_archive_playlist;
    print '<a class="main_links" href="./offline/playlist.php" title="' . $a_archive_playlist . '">
        <img src="./img/offline_playlist.jpg"
        width="236" height="165" border="0"></a>' . "\n";
    print '<p align="center"><a class="main_links" href="./offline/playlist.php">' . $a_archive_playlist . '</a></p>' .
        "\n";
}

function printArchGallery()
{
    global $a_archive_gallery;
    print '<a class="main_links" href="./offline/gallery.php" title="' . $a_archive_gallery . '">
        <img src="./img/offline-gallery-4.png"
        border="0"></a>' . "\n";
    print '<p align="center"><a class="main_links" href="./offline/gallery.php">' . $a_archive_gallery . '</a></p>' .
        "\n";
}

print '<table id="main_tab" cellspacing="20" border="0" cellpadding="0" align="center">' .
    "\n";
print '<tbody>' . "\n";
print '<tr>' . "\n";
//pda
print '<td align="center" valign="top" nowrap >' . "\n";
if ($allow_pda) {
    printCellular();
}
print '</td>' . "\n";

//online
print '<td align="center" valign="top" >' . "\n";
printOnline();
print '</td>' . "\n";
//админка
print '<td align="center" valign="top" >' . "\n";
if ($admin_user /* config.inc.php */) {
    printAdmin();
} else {
    print "&nbsp;\n";
}
print '</td>' . "\n";

print '</tr>' . "\n";

if ($arch_user) {
    print '<tr>' . "\n";
    //Архив :: поиск
    print '<td align="center" valign="top" >' . "\n";
    if (!$IS_IOS) {
        printArchSearch();
    } else {
        print "&nbsp;\n";
    }
    print '</td>' . "\n";

    //Архив :: плейлист
    print '<td align="center" valign="top" >' . "\n";
    if (!$IS_IOS) {
        printArchPlaylist();
    } else {
        printArchSearch();
        ;
    }
    print '</td>' . "\n";

    //Gallery
    print '<td align="center" valign="top" >' . "\n";
    printArchGallery();
    print '</td>' . "\n";

    print '</tr>' . "\n";
}
print '</tbody>' . "\n";
print '</table>' . "\n";

if ($conf['debug']) {
    tohtml($conf);
    // phpinfo(INFO_VARIABLES);
}

// file_put_contents('/tmp/conf.txt', print_r($conf, true));

require $wwwdir . '/foot.inc.php';
