<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
/**
 * @file lang/russian/utf-8/_offline.php
 * @brief Файл переводов для страниц
 * - offline/index.php
 * - offline/query.php
 * - offline/result.php
 * - offline/_res.form.inc.php
 * - offline/view-image.php
 * - offline/playlist.php
 * - offline/_playlist.php
 */


$strEmbedPlayerSettingsHeader = 'Встроенный медиаплеер';
$strPlaylistSettingsHeader = 'Плейлист (слева)';

$str_row_maxTitle = 'Ссылок на одну страницу';
$str_embed_Title = 'Попытаться проиграть аудио/видео в верхнем левом фрейме (участке окна)';

$strEmbdedVideo = &$strEmbedPlayerSettingsHeader;
$strPlaybackRates = 'Cкорость проигрывания (по умолчанию)';
$strSlowMotionPlaybackRates = 'замедленная скорость проигрывания (левый CTRL)';

$strTimeMode = 'время';

$htmlTimeSlicesModeHelp = <<<EOL
<p>
Если &quot;$strIntervals&quot <i>выключены</i>; то будут выбраны события,
возникшие в <i>единственном</i> диапазоне:
<span class='text-nowrap'>[ год/месяц/день час:минута -</span>
<span class='text-nowrap'> год/месяц/день час:минута ]</span>
</p>
<p>
Если же &quot;$strIntervals&quot; <i>включен</i>,
то в выбранном диапазоне ДАТ [ год/месяц/день - год/месяц/день ] за ОДИН запрос
можно будет получить все события/файлы, записанные, например, во все Пн,Ср,Пт и только
с 10:00 до 11:30.
</p>
<p>
Последний режим несколько медленнее, но очень удобен для поиска в  некоторых жизненных ситуациях.
</p>
EOL;

$htmlTimeSlicesModeHelp2 = 'Использутся только когда включен параметр &quot;' . $strIntervals . '&quot;';
$strNoEvents = <<<'EOL'
В базе данных не найдено ни одного события и(или) файла,
удовлетворяющим выбранным Вами параметрам поиска.
EOL;

$strNoEventsLeft = 'Уже было показано первое событие в текущем списке.';
$strNoEventsRight = 'Уже было показано последнее событие в текущем списке.';

$sFromDate = 'с этой даты';
$sToDate = 'по эту дату';
$sFromTime = 'с этого врем.';
$sToTime = 'по это время';

$strFromToDateRange = 'Введите диапазон дат';
$htmlSearchHelp = <<<'EOL'
<h2>Краткая инструкция по использованию интерфейса Архив::Поиск</h2>

<div class="paragraph indented">
    В форме сверху сформируйте условия выборки из архива:
<ul>
    <li>список видеокамер;</li>
    <li>интервалы времени (год, месяц и т.д.);</li>
    <li>список типов событий, хотя бы одно;</li>
    <li>др. параметры</li>
</ul>
</div>

<div class="paragraph">
и нажмите один раз на кнопку &#171;Получить&#187; в форме запроса для
отображения списка (плейлиста) событий в левой части окна.
</div>

<div class="paragraph indented">
Выбирая вручную события <b>в списке слева</b> или запустив автоматическое проигрывание,
в этой части окна будут отображаться аудио/видео фрагменты, кадры JPEG, текстовая информация.
</div>

<div class="paragraph indented">
<b>Встроенный медиаплеер</b>, помимо интуитивно понятного управления мышью
и <mark>при наличии фокуса на нём (красная рамка)</mark>, имеет возможность управления с клавиатуры:
</div>
<dl class="row">
  <dt class="col-xs-6 text-right">Space (пробел)</dt>
  <dd class="col-xs-12">Play|Pause (Воспроизведение|Стоп-кадр);</dd>
  <dt class="col-xs-6 text-right">левый Ctrl</dt>
  <dd class="col-xs-12">замедленное воспроизведение со скоростью, заданной в настройках <i class="glyphicon glyphicon-wrench"></i>;</dd>
  <dt class="col-xs-6 text-right">правый Ctrl</dt>
  <dd class="col-xs-12">воспроизведение с нормальной (1x) скоростью.</dd></dl>
EOL;

$strPlaylistAfterMediaEndPause =
    'Пауза в сек. перед переключением на следующее событие после проигрывания ролика до конца';
$strPlaylistTextDuration = 'Продолжительность в сек. отображения текстовых событий.';

// playlist controls
$strPlaylistToHead = 'Первый';
$strPlaylistToTail = 'Последний';
$strPlaylistNext = 'Следующий';
$strPlaylistPrev = 'Предыдущий';
$strPlaylistPlayForward = 'Все подряд до конца';
$strPlaylistPlayBackward = 'Все подряд до начала';
$strPlaylistStop = 'Остановить';

$strFactEventsRange = 'Фактический диапазон выбранных событий';
$strNextEventsPage = 'Следующая страница событий';
$strPrevEventsPage = 'Предыдущая страница событий';

$strToday = 'Сегодня';
$strYesterday = 'Вчера';
$strThisWeek = 'Эта неделя';
$strLastWeek = 'Прошлая неделя';
$strThisMonth = 'Этот месяц';
$strLastMonth = 'Прошлый Месяц';

$strCustomChoice = 'Свой выбор';

$fmtDownloadPrompt = 'Вы уверены что хотите загрузить %s ZIP-архив c %u файлом(и)?';
$fmtDownloadZipTooLarge = <<<'EOL'
Ошибка!

Предполагаемый архив размером %s слишком большой для формата ZIP.

Сократите количество файлов для скачивания, чтобы общий размер файлов получился не более 4ГБ.
EOL;

/* playlist.php */

$PlaylistTitle = 'Архив::Плейлист';
$GetPlaylistStr = 'Открыть плейлист';
$strXSPF = '<strong>XSPF</strong> - современный продвинутый свободный формат, основанный на XML.';
$strM3U = '<strong>M3U</strong> - формат компании Nullsoft (Winamp), &quot;понимается&quot; большинством
 медиа-проигрывателей.';
$strTXT = '<strong>TXT</strong> - просто список ссылок на файлы (для подсовывания программам - менеджерам загрузок).';

$strPlFmtTitle = 'Формат файла плейлиста';
$strFTypeTitle = 'Типы медиафайлов для воспроизведения';
$strTimeRangeSelect = 'Ограничение по времени';

$strLinesEnding = 'Окончание строки';

$strBrowserHandlers = 'Будет ли файл плейлиста автоматически открыт в медиа-плеере (и каком конкретно) или сохранён ' .
    'на диске (и в каком каталоге) зависит от настроек &quot;привязки типов файлов&quot; в вашем интернет-браузере ' .
    '(IE, FF, Opera, ...) и, возможно, в графической среде окружения (GNOME, KDE, ...) или даже в системе ' .
    '(Win, Linux, Mac). Например, в Mozilla Firefox: меню &quot;Правка&quot; &#8250; &quot;Настройки&quot;, ' .
    'далее вкладка &quot;Приложения&quot;.';

$strPlaylistOpenHelp = 'Для просмотра плейлиста рекомендуем пользоваться свободно-распространяемым
кросс-платформеннымы медиа-проигрывателем <a href="http://www.videolan.org/" target="_blank">VLC</a>.';

$strMassCopy = 'Для копирования части архива на основе сформированного плейлиста используйте M3U плейллист ' .
    'и локальное GUI-приложение &#171;Импорт плейлистов&#187; (пакет avreg-pi-gtk2) или TXT-список и ' .
    'wget (<span class="cmd">wget -c -x -nH --cut-dirs=1 -i список.txt</span>).';

$playlistFormValidationErrors = array(
    'title' => 'Форма заполнена некорректно',
    'noCams' => 'необходимо выбрать хотя бы одну камеру',
    'noEvents' => 'необходимо выбрать тип медиафайлов для воспроизведения',
    'noWeekdays' => 'необходимо выбрать дни недели интервала',
    'noDateRange' => 'необходимо определить диапазон дней',
    'invalidDateRange' => 'некорретный диапазон дней',
    'noTimeRange' => 'необходимо определить интервал времени',
    'invalidTime' => 'некорректное начальное и/или конечное время'
);

$strNotCamsDef2 = 'Нет ни одной видеокамеры, сконфигурированной для записи.';
