<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

namespace Avreg;

require (__DIR__ . '/OnvifClient.php');
require (__DIR__ . '/../AjaxController.php');

class OnvifAjaxController extends AjaxController
{
    /**
     * @type \OnvifClient
     */
    private $onvifClient;

    protected $cache;
    protected $onvifData;

    private function connect($data = array())
    {
         global $conf;

        if (!isset($data['cameraNumber'])) {
            throw new \Exception(get_class()  . ' error: cameraNumber not set');
        }

        if (isset($data['username']) && !empty($data['username'])) {
            $credentials = true;
        }

        $this->onvifClient = new \OnvifClient($data);
    } /* connect() */

    protected function camKey($camNbr) {
        return "cam_$camNbr";
    }

    public function checkConnection($data = array())
    {
        $this->connect($data);

        $r = $this->onvifClient->doSoapRequest(\OnvifServices::DEVICEMANAGEMENT, 'GetCapabilities');

        if (!$r['isOk']) {
            $this->error(isset($r['exception']) ? $r['exception']->getMessage() : false);
        } else {
            $this->success();
        };
    }

    public function doRequest(array $connectionData, string $services, string $command, array $props = null)
    {
        $this->connect($connectionData);

        $ret = $this->onvifClient->doSoapRequest($services, $command, $props);
        return array(
            'isOk' => $ret['isOk'],
            'result' => isset ($ret['result']) ? $ret['result'] : null,
            'debug' => isset ($ret['debug']) ? $ret['debug'] : null,
            'error_message' => isset($ret['exception']) ? $ret['exception']->getMessage() : false
        );
    }
}
