<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

/**
 *рекурсивно комбинирует конфигурационные общие(для всех ОС) настройки плеера с настройками для ОС пользователя
 * @param unknown_type $star_marked - общие настройки для всех ОС (с индексом ['*'] - $conf['aplayerConfig']['*'])
 * @param unknown_type $res_out - ссылка на результирующий массив с параметрами для клиентской ОС
 */
function config_merging_part($star_marked, &$res_out)
{
    if (gettype($star_marked) != 'array') {
        return;
    }

    foreach ($star_marked as $key => $val) {
        if (isset($res_out[$key])) {
            config_merging_part($val, $res_out[$key]);
        } else {
            $res_out[$key] = $val;
        }
    }
}

/**
 * возвращает объект для конфигурации плеера для клиентской ОС
 * @param array $aplayer_config - массив $conf['aplayerConfig']
 */
function aplayer_configurate($aplayer_config)
{
    $has_asterisk_conf = array_key_exists('*', $aplayer_config);
    $has_linux_conf = array_key_exists('linux', $aplayer_config);
    $has_windows_conf = array_key_exists('windows', $aplayer_config);
    $pl_conf = null;
    $ua = strtolower($_SERVER["HTTP_USER_AGENT"]);

    if (false !== strpos($ua, 'linux')) {
        if ($has_linux_conf) {
            $pl_conf =& $aplayer_config['linux'];
        }
    } elseif (false !== strpos($ua, 'windows')) {
        if ($has_windows_conf) {
            $pl_conf =& $aplayer_config['windows'];
        }
    } elseif (false !== strpos($ua, 'android')) {
        if ($has_windows_conf) {
            $pl_conf =& $aplayer_config['android'];
        }
    } elseif (false !== strpos($ua, 'ipad')) {
        if ($has_windows_conf) {
            $pl_conf =& $aplayer_config['ipad'];
        }
    } elseif (false !== strpos($ua, 'iphone')) {
        if ($has_windows_conf) {
            $pl_conf =& $aplayer_config['iphone'];
        }
    } elseif (false !== strpos($ua, 'mac os') /*XXX после всех других ios */) {
        if ($has_windows_conf) {
            $pl_conf =& $aplayer_config['mac'];
        }
    }

    if (!empty($pl_conf)) {
        if ($has_asterisk_conf) {
            config_merging_part($aplayer_config['*'], $pl_conf);
            return $pl_conf;
        } else {
            return $pl_conf;
        }
    } else {
        if ($has_asterisk_conf) {
            return $aplayer_config['*'];
        } else {
            return null;
        }
    }
}

