<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

$__selectElAttrDef = array(
    'size' => 1,
    'start' => 1,
    'multiple' => false
);

/**
 *
 * Функция формирует и возвращает елемент select
 * @param string $_name название
 * @param array $values масив значений
 * @param bool $_multiple разрешить множественный выбор
 * @param int $_size размер
 * @param int $start_val начальное значение
 * @param string $selected выбранные значения
 * @param bool $first_empty пустое первое значение
 * @param string $onch функция onchange
 * @param string $TITLE заголовок
 * @return string
 */
function genSelectHtml($values, $selected = false, $first_empty = true, $elAttr = array())
{
    $attr = array_merge($GLOBALS['__selectElAttrDef'], $elAttr);

    $html = '<select';

    foreach ($attr as $attrName => $attrValue) {
        $html .= ' ';
        $attrValueType = gettype($attrValue);
        switch ($attrValueType) {
            case 'boolean':
                if ($attrValue) {
                    $html .= $attrName;
                }
                break;
            case 'integer':
            case 'double':
            case 'string':
                $html .= $attrName . '="' . $attrValue . '"';
                break;
            case 'array':
                $html .= $attrName . '="' . implode(' ', $attrValue) . '"';
                break;
        }
    }
    $html .= ">\n";

    if ($first_empty) {
        $html .= '<option></option>' . "\n";
    }

    if ($selected) {
        if (!is_array($selected)) {
            $selected = explode(' ', strval($selected));
        }
    } else {
        $selected = array();
    }

    foreach ($values as $key => $value) {
        $_append = '';

        if (gettype($key) === 'integer') {
            $key = $value;
        }

        if (!empty($selected)) {
            if (in_array($value, $selected)) {
                $_append = 'selected';
            }
        }
        $html .= '<option value="' . $key . '" ' . $_append . '>' . $value . '</option>' . "\n";
    }

    $html .= "</select>\n";

    return $html;
}
