<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

require_once (__DIR__ . '/config.inc.php'); // is_assoc()

/**
 *
 * Функция формирует и возвращает елемент select
 * @param string $parName названи
 * @param array $value_array масив значений
 * @param bool $_multiple разрешить множественный выбор
 * @param int $_size размер
 * @param int $start_val начальное значение
 * @param string $selected выбранные значения
 * @param bool $first_empty пустое первое значение
 * @param string $onch функция onchange
 * @param string $TITLE заголовок
 * @return string
 */
function getSelectHtml(
    $parName,
    $value_array,
    $_multiple = false,
    $_size = 1,
    $start_val = 1,
    $selected = '',
    $first_empty = true,
    $onch = false,
    $TITLE = null
) {
    settype($selected, 'string');
    if ($_multiple) {
        $m = 'multiple="multiple"';
    } else {
        $m = '';
    }
    if ($onch === true) {
        $onch = 'onchange="this.form.submit()"';
    } elseif (!empty($onch)) {
        $onch = 'onchange="' . $onch . '"';
    } else {
        $onch = '';
    }
    if (!empty($TITLE)) {
        $_title = 'title="' . $TITLE . '"';
    } else {
        $_title = '';
    }
    $a = sprintf(
        '<select name="%s" id="%s" %s size="%d" %s %s>' . "\n",
        $parName,
        $parName,
        $m,
        $_size,
        $_title,
        $onch
    );

    if ($first_empty) {
        $a .= '<option></option>' . "\n";
    }
    $_cnt = $start_val;
    foreach ($value_array as $_element) {
        if ($selected != '') {
            if ($_multiple) {
                $_y = false;
                $ar = explode(',', $selected);
                foreach ($ar as $sss) {
                    if ($_cnt == $sss) {
                        $_y = true;
                        break;
                    }
                }
                if ($_y) {
                    $a .= '<option value="' . $_cnt . '" selected>' . $_element . '</option>' . "\n";
                } else {
                    $a .= '<option value="' . $_cnt . '">' . $_element . '</option>' . "\n";
                }
            } else {
                /* not multiple */
                if ($_element == $selected) {
                    $a .= '<option value="' . $_cnt . '" selected>' . $_element . '</option>' . "\n";
                } else {
                    $a .= '<option value="' . $_cnt . '">' . $_element . '</option>' . "\n";
                }
            }
        } else { // not selected
            $a .= '<option value="' . $_cnt . '">' . $_element . '</option>' . "\n";
        }
        $_cnt++;
    }
    $a .= '</select>' . "\n";
    return $a;
}

/**
 *
 * Функция формирует и возвращает елемент select используя значения
 * @param string $parName названиe
 * @param array $value_array масив значений
 * @param bool $_multiple разрешить множественный выбор
 * @param int $_size размер
 * @param int $start_val начальное значение
 * @param string $selected выбранные значения
 * @param bool $first_empty пустое первое значение
 * @param string $onch функция onchange
 * @param string $text_prefix префикс
 * @param string $TITLE заголовок
 * @return string
 */
function getSelectHtmlByName(
    $parName,
    $value_array,
    $_multiple = false,
    $_size = 1,
    $start_val = 0,
    $selected = '',
    $first_empty = true,
    $onch = false,
    $text_prefix = '',
    $TITLE = null,
    $cams_srcs = null
) {
    if ($_multiple) {
        $m = 'multiple="multiple"';
    } else {
        $m = '';
    }
    if ($onch === true) {
        $onch = 'onchange="this.form.submit()"';
    } elseif (!empty($onch)) {
        $onch = 'onchange="' . $onch . '"';
    } else {
        $onch = '';
    }
    if (isset($TITLE) && !empty($TITLE)) {
        $_title = 'title="' . $TITLE . '"';
    } else {
        $_title = '';
    }

    $posn = strpos($parName, '[]');
    if ($posn !== false) {
        $_id = substr_replace($parName, '', $posn);
        $_class = $_id;
    } else {
        $_id = $parName;
    }
    $_class = $_id;

    $a = sprintf(
        '<select name="%s" id="%s" class="%s" %s size="%d" %s %s>' . "\n",
        $parName,
        $_id,
        $_class,
        $m,
        $_size,
        $_title,
        $onch
    );

    if ($first_empty) {
        $a .= '<option> </option>' . "\n";
    }
    $_cnt = $start_val;

    //Если для веб-раскладок => $cams_srcs - содержит алтернативные источники
    if ($cams_srcs != null) {

        foreach ($value_array as $_element) {
            $set_src_type = 0;
            if ($selected != null) {
                if ($_multiple) {
                    $_y = false;
                    $ar = explode(',', $selected[0]);
                    foreach ($ar as $sss) {
                        if ($_cnt == $sss) {
                            $_y = true;
                            break;
                        }
                    }
                    if ($_y) {
                        $a .= '<option value="' . $_element . '" selected>' . $text_prefix . $_element . '</option>' .
                            "\n";
                    } else {
                        $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' . "\n";
                    }
                } else {
                    /* not multiple */
                    if ($_element == $selected[0]) {
                        $a .= '<option value="' . $_element . '" selected>' . $text_prefix . $_element . '</option>' .
                            "\n";
                    } else {
                        $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' . "\n";
                    }
                }
            } else { // not selected
                $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' . "\n";
            }
            $_cnt++;
        }
        $a .= '</select>' . "\n";


        $set_src_type = (isset($selected[1]) ? $selected[1] : 0);
        $visi_val = $set_src_type != 0 ? 'visible' : 'hidden';

        $a .= '<br />';
        //Добавление типа источника камеры для веб-раскладок
        if ($cams_srcs != false && (isset($cams_srcs[@$selected[0]]['avregd']) ||
                isset($cams_srcs[@$selected[0]]['alt_1']) || isset($cams_srcs[@$selected[0]]['alt_2']))) {

            $a .= '<select class="mon_wins_type" name="mon_wins_type[]" size="' . $_size . '" ' . $_title
                . ' style="font-size:8pt; visibility:' . $visi_val . ';" >' . "\n";

            if (isset($cams_srcs[$selected[0]]['avregd']) && $cams_srcs[$selected[0]]['avregd']) {
                $a .= '<option ' . ($set_src_type == 1 ? 'selected="selected"' : '') . ' value="1">avregd</option>' .
                    "\n";
            }
            if (isset($cams_srcs[$selected[0]]['alt_1']) && $cams_srcs[$selected[0]]['alt_1']) {
                $a .= '<option ' . ($set_src_type == 2 ? 'selected="selected"' : '') . ' value="2">alt 1</option>' .
                    "\n";
            }
            if (isset($cams_srcs[$selected[0]]['alt_2']) && $cams_srcs[$selected[0]]['alt_2']) {
                $a .= '<option ' . ($set_src_type == 3 ? 'selected="selected"' : '') . ' value="3">alt 2</option>' .
                    "\n";
            }
            $a .= '</select>' . "\n";
        }

    } else {

        foreach ($value_array as $_element) {
            if ($selected != '') {
                if ($_multiple) {
                    $_y = false;
                    $ar = explode(',', $selected);
                    foreach ($ar as $sss) {
                        if ($_cnt == $sss) {
                            $_y = true;
                            break;
                        }
                    }
                    if ($_y) {
                        $a .= '<option value="' . $_element . '" selected>' . $text_prefix . $_element . '</option>' .
                            "\n";
                    } else {
                        $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' . "\n";
                    }
                } else {
                    /* not multiple */
                    if ($_element == $selected) {
                        $a .= '<option value="' . $_element . '" selected>' . $text_prefix . $_element . '</option>' .
                            "\n";
                    } else {
                        $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' .
                            "\n";
                    }
                }
            } else { // not selected
                $a .= '<option value="' . $_element . '">' . $text_prefix . $_element . '</option>' . "\n";
            }
            $_cnt++;
        }
        $a .= '</select>' . "\n";
    }

    return $a;
}

/**
 *
 * Функция формирует и возвращает елемент select используя значения
 * @param string $parName названи
 * @param hash $dictionary
 * @param bool $_multiple разрешить множественный выбор
 * @param int $_size размер
 * @param int $start_val начальное значение
 * @param string $selected выбранные значения
 * @param bool $first_empty пустое первое значение
 * @param string $onch функция onchange
 * @param string $text_prefix префикс
 * @param string $TITLE заголовок
 * @param bool $opts['keyValueReverse'] использовать обратные ключи-значения
 * @return string
 */
function getSelectByAssocAr(
    $parName,
    $dictionary,
    $_multiple = false,
    $_size = 1,
    $start_val = null,
    $selected = null,
    $first_empty = true,
    $onch = false,
    $text_prefix = null,
    $TITLE = null,
    $_reverse = false
) {
    $array_cnt = count($dictionary);
    if ($array_cnt === 0) {
        return '';
    }
    if ($_multiple) {
        $m = 'multiple="multiple"';
    } else {
        $m = '';
    }
    if ($onch === true) {
        $onch = 'onchange="this.form.submit()"';
    } elseif (!empty($onch)) {
        $onch = 'onchange="' . $onch . '"';
    } else {
        $onch = '';
    }
    if (!empty($TITLE)) {
        $_title = 'title="' . $TITLE . '"';
    } else {
        $_title = '';
    }
    $a = sprintf(
        '<select name="%s" id="%s" %s size="%d" %s %s>' . "\n",
        $parName,
        $parName,
        $m,
        $_size,
        $_title,
        $onch
    );

    if ($first_empty) {
        $a .= '<option></option>' . "\n";
    }
    foreach ($dictionary as $k => $v) {
        if ($_reverse) {
            $key = & $v;
            $value = & $k;
        } else {
            $key = & $k;
            $value = & $v;
        }

        if ($selected != '') {
            if ($_multiple) {
                $_y = false;
                $ar = explode(',', $selected);
                foreach ($ar as $sss) {
                    if ($key == $sss) {
                        $_y = true;
                        break;
                    }
                }
                if ($_y) {
                    $a .= '<option value="' . $key . '" selected>' . $text_prefix . $value . '</option>' . "\n";
                } else {
                    $a .= '<option value="' . $key . '">' . $text_prefix . $value . '</option>' . "\n";
                }
            } else {
                /* not multiple */
                if ($key == $selected) {
                    $a .= '<option value="' . $key . '" selected>' . $text_prefix . $value . '</option>' . "\n";
                } else {
                    $a .= '<option value="' . $key . '">' . $text_prefix . $value . '</option>' . "\n";
                }
            }
        } else { // not selected
            $a .= '<option value="' . $key . '">' . $text_prefix . $value . '</option>' . "\n";
        }
    }

    $a .= '</select>' . "\n";
    return $a;
}

/**
 *
 * Функция формирует разметку с набором чекбоксов для выбора значений
 * @param string $parName базовое имя для идентификации эл-тов
 * @param array $dictionary ассоциативный массив с названиями и значениями чекбоксов
 * @param string|array $selected строка с номерами п/п чекнутых эл-тов
 * @param bool $opts['showSelectAll'] выводить чекбокс выбора/сброса всех чекбоксов
 * @param int $_size кол-во одновременно отображаемых чекбоксов(без учета "Выбрать все")
 * @param string $text_prefix строка, добавляемая вначало к названию всех чекбоксов
 * @param bool $opts['keyValueReverse'] поменять местами использование ключей и значеий ассоц. массива при генерации
 * разметки
 * чекбоксов
 * @return string результирующая разметка
 */
function getChkbxByArray(
    $parName,
    $dictionary,
    //выбранные значения
    $selected = null,
    $opts = null
) {
    $_selArray = null;

    if (empty($dictionary)) {
        return '';
    }

    $is_assoc_dict = is_assoc($dictionary);

    $defaultOpts = array(
        'showSelectAll' => true, // Выбор всех значений
        'limitInputs' => 0,      // ограничитель отображаемых чекбоксов
        'selectedDelim' => ',',  // разделитель для выранных элеметнов в $selected, если она (переменная) - строка
        'textPrefix' => '',
        'keyValueReverse' => false
    );

    if (is_array($opts)) {
        $opts = array_merge ($defaultOpts, $opts);
    } else {
        $opts = &$defaultOpts;
    }

    $selAll_Localesed = array(
        'select_all' => "Выбрать все",
        'deselect_all' => "Снять выбор"
    );

    $_limitInputs = (int)$opts['limitInputs'];

    if (@!empty($selected)) {
        switch (gettype($selected)) {
        case 'array':
            $_selArray = & $selected;
            break;
        case 'string':
            $_selArray = explode($opts['selectedDelim'], $selected);
            break;
        }
    }

    $a = '<div id="id_main_' . $parName . '" class="chkbx_lsl" >' . "\n";

    $cnt_selected_itms = 0; //счетчик чекнутых чекбоксов
    //заголовок с чекбоксом "Выбрать все"
    if ($opts['showSelectAll']) {
        $a .= '<div id="id_head_' . $parName . '" class="chkbx_lsl_head" >' . "\n";
        $a .= '<div style="text-align:left; clear:both;">' . "\n";
        $a .= '<div style="float:left; position:relative; top:-3px;">';
        $a .= '<input type="checkbox" id="id_' . $parName . '_select_all" name="' . $parName .
            '_select_all" value="select_all" onclick="chbox_select_all(\'' . $parName . '\')" /> ' . "\n";
        $a .= '</div>' . "\n";
        $a .= '<div>';
        $a .= '<label for="id_' . $parName . '_select_all" class="chbox_head " >' . $selAll_Localesed['select_all'] .
            '</label><br />' . "\n";
        $a .= '</div>' . "\n";
        $a .= '</div>' . "\n";
        $a .= '</div>' . "\n";
    }

    //контейнер набора чекбоксов
    $a .= '<div id="id_' . $parName . '" style="text-align:left; overflow-y:auto; position:relative; width:100%;">' .  "\n";

    foreach ($dictionary as $k => $v) {
        if (!$is_assoc_dict) {
            $k = $v;
        }

        //реверс - меняем местами ключ-значение
        if ($opts['keyValueReverse']) {
            $key = & $v;
            $value = & $k;
        } else {
            $key = & $k;
            $value = & $v;
        }

        $a .= '<div style="text-align:left; clear:both;">' . "\n";
        $a .= '<div style="float:left;">';

        //определяем чекнутые эл-ты
        if ($_selArray) {
            //генерируем разметку чекбоксов
            if (in_array($key , $_selArray)) {
                $a .= '<input type="checkbox" class="chbox_itm " id="id_' . $parName . $key . '"  name="' . $parName .
                    '[]" onclick="chbox_itm_clk(\'' . $parName . '\')" value="' . $key . '" checked />' . "\n";
                $cnt_selected_itms++;
            } else {
                $a .= '<input type="checkbox" class="chbox_itm " id="id_' . $parName . $key . '" name="' . $parName .
                    '[]" onclick="chbox_itm_clk(\'' . $parName . '\')" value="' . $key . '" />' . "\n";
            }
        } else { // not selected
            $a .= '<input type="checkbox" class="chbox_itm " id="id_' . $parName . $key . '" name="' . $parName .
                '[]" onclick="chbox_itm_clk(\'' . $parName . '\')" value="' . $key . '" />' . "\n";
        }
        $a .= '</div>';
        //генерируем разметку подписей чекбоксов
        $a .= '<div><label for="id_' . $parName . $key . '" class="class_' . $parName . ' ">' . $opts['textPrefix'] . $value .
            '</label>' . "\n";
        $a .= '</div>';
        $a .= '</div>';
    }

    $a .= '</div>' . "\n";
    $a .= '</div>' . "\n";

    //клиентские скрипты поведения и начального состояния
    $a .= '<script type="text/javascript">' . "\n";
    $a .= "initCheckBox('" . $parName . "', $_limitInputs) ";
    $a .= '</script>' . "\n";
    return $a;
} // getChkbxByArray()
