/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
(function(root,factory){if(typeof(define)==='function'&&define.amd){define([],factory(root));}else if(typeof(exports)==='object'){module.exports=factory(root);}else{root.PlaylistControllers=factory(root);}})(typeof(global)!=='undefined'?global:this.window||this.global,function(root){'use strict';var PlaylistControllers={};var allControllers={};var defaults_={controlsClassPrefix:'pl-',listItemTimeout:500};PlaylistControllers.add=function(container,options){var
parType=typeof(container),contEl,options_,PlaylistController;options_=$.extend({},defaults_,options||{});if(parType==='string'){contEl=document.getElementById(container);}else if(parType==='object'){if(isElement(container)){contEl=container;}else if(container instanceof jQuery){contEl=container.get(0);}}
if(!contEl){throw new Error('Invalid argument container '+container);}
if(!contEl.id||contEl.id===''){throw new Error('Container element must have the id atrribute');}
if(allControllers[contEl.id]){throw new Error('This container already assigned to controller');}
PlaylistController=function(container,options){var
$container=$(container),curState,allStateNames,playbackDirection,timer,getControlClass,i,c,stname,s;this.list_=undefined;this.listLength_=undefined;this.listPosition_=undefined;getControlClass=function(actionName){return options.controlsClassPrefix+actionName;};this.states_={'initial':{enter:function(){this.updateControls_(true);}},'input':{enter:function(){this.updateControls_();}},'waiting':{enter:function(){this.updateControls_(true);}},'head':{$control:$container.find('.'+getControlClass('head')),beAllowed:function(){return(this.listLength_>0&&(isNaN(this.listPosition_)||this.listPosition_>0));},enter:function(){this.transitionTo_('waiting');this.setPosition_(0);}},'tail':{$control:$container.find('.'+getControlClass('tail')),beAllowed:function(){return(this.listLength_>0&&(isNaN(this.listPosition_)||this.listPosition_<(this.listLength_-1)));},enter:function(){this.transitionTo_('waiting');this.setPosition_(this.listLength_-1);}},'backward':{$control:$container.find('.'+getControlClass('backward')),beAllowed:function(){return(this.listLength_>0&&(isNaN(this.listPosition_)||this.listPosition_>0));},enter:function(){var pos=isNaN(this.listPosition_)?0:this.listPosition_-1;this.transitionTo_('waiting');this.setPosition_(pos);}},'forward':{$control:$container.find('.'+getControlClass('forward')),beAllowed:function(){return(this.listLength_>0&&(isNaN(this.listPosition_)||this.listPosition_<(this.listLength_-1)));},enter:function(){var pos=isNaN(this.listPosition_)?0:this.listPosition_+1;this.transitionTo_('waiting');this.setPosition_(pos);}},'play_backward':{$control:$container.find('.'+getControlClass('play-backward')),beAllowed:function(){return(this.listLength_>0&&!(playbackDirection)&&this.listPosition_>0);},enter:function(){var startPos,$control=this.states_['play_backward'].$control;startPos=(isNaN(this.listPosition_))?this.listLength_-1:this.listPosition_-1;this.transitionTo_('waiting');this.setPosition_(startPos);if(!$.isEmptyObject($control)){if(!$control.hasClass('active')){$control.addClass('active');}}}},'play_stop':{$control:$container.find('.'+getControlClass('play-stop')),beAllowed:function(){return(this.listLength_>0&&!!(playbackDirection));},enter:function(){this.transitionTo_('input');['backward','forward'].every(function(element){var
_state='play_'+element,$control=this.states_[_state].$control;if(!$.isEmptyObject($control)){if($control.hasClass('active')){$control.removeClass('active');return false;}else{return true;}}},this);}},'play_forward':{$control:$container.find('.'+getControlClass('play-forward')),beAllowed:function(){return(this.listLength_>0&&!(playbackDirection)&&this.listPosition_<(this.listLength_-1));},enter:function(){var
startPos,$control=this.states_['play_forward'].$control;startPos=(isNaN(this.listPosition_))?0:this.listPosition_+1;this.transitionTo_('waiting');this.setPosition_(startPos);if(!$.isEmptyObject($control)){if(!$control.hasClass('active')){$control.addClass('active');}}}}};allStateNames=Object.keys(this.states_);this.updateControls_=function(forceLock){var i,c,state,disabled;c=allStateNames.length;for(i=0;i<c;i+=1){state=this.states_[allStateNames[i]];if(!$.isEmptyObject(state.$control)){disabled=forceLock||!state.beAllowed.apply(this);state.$control.prop('disabled',disabled);}}};this.setPosition_=function(num){var endType;if(num===this.listPosition_){return;}
if(num<0||num>=this.listLength_){if(this.$observer_.data('events').hasOwnProperty('end')){endType=(num<0)?'head':'tail';this.$observer_.trigger('end',[endType]);if(playbackDirection){this.play_stop();}
this.updateControls_();return;}else{throw new RangeError('Playlist position must be between [0..'+(this.listLength_-1)+']');}}
this.$observer_.trigger('change',[{last:{idx:this.listPosition_,data:isNaN(this.listPosition_)?undefined:this.list_[this.listPosition_]},cur:{idx:num,data:this.list_[num]}}]);this.listPosition_=num;this.updateControls_();};this.transitionTo_=function(newState){var lastState;if(newState===curState){return;}
this.states_[curState]&&this.states_[curState].exit&&this.states_[curState].exit.apply(this);lastState=curState;curState=newState;this.states_[curState]&&this.states_[curState].enter&&this.states_[curState].enter.apply(this);this.$observer_.trigger('state-change',[curState,lastState]);this.states_[lastState]&&this.states_[lastState].exit&&this.states_[lastState].exit.apply(this);};this.$observer_=$({});this.on=function(){if(arguments[1]&&typeof(arguments[1])==='function'){arguments[1]=arguments[1].bind(this);}
this.$observer_.on.apply(this.$observer_,arguments);return this;};this.one=function(){if(arguments[1]&&typeof(arguments[1])==='function'){arguments[1]=arguments[1].bind(this);}
this.$observer_.one.apply(this.$observer_,arguments);return this;};this.off=function(){this.$observer_.off.apply(this.$observer_,arguments);return this;};this.load=function(listData){this.list_=listData;this.listLength_=listData.length;this.listPosition_=undefined;curState=undefined;this.transitionTo_('input');return this;};this.itemLoaded=function(){this.transitionTo_('input');return this;};this.itemError=function(){if(playbackDirection){this.play_stop();}
return this;};this.itemEnded=function(nextDelay){nextDelay=isNaN(nextDelay)?options.listItemTimeout:nextDelay;if(playbackDirection>0){timer=setTimeout(this.play_forward.bind(this),nextDelay);}else if(playbackDirection<0){timer=setTimeout(this.play_backward.bind(this),nextDelay);}
return this;};this.selectItem=function(idx){var pos=isNaN(idx)?0:idx;this.play_stop();this.transitionTo_('waiting');this.setPosition_(pos);};this.head=function(){if(playbackDirection){this.play_stop();}
this.transitionTo_('head');return this;};this.tail=function(){if(playbackDirection){this.play_stop();}
this.transitionTo_('tail');return this;};this.backward=function(){if(playbackDirection){this.play_stop();}
this.transitionTo_('backward');return this;};this.forward=function(){if(playbackDirection){this.play_stop();}
this.transitionTo_('forward');return this;};this.play_backward=function(){if(playbackDirection!==-1){if(playbackDirection){this.play_stop();}
playbackDirection=-1;}
this.transitionTo_('play_backward');return this;};this.play_stop=function(){if(playbackDirection){playbackDirection=0;clearTimeout(timer);this.transitionTo_('play_stop');}
return this;};this.play_forward=function(){if(playbackDirection!==1){if(playbackDirection){this.play_stop();}
playbackDirection=1;}
this.transitionTo_('play_forward');return this;};for(i=0,c=allStateNames.length;i<c;i+=1){stname=allStateNames[i];s=this.states_[stname];if(!$.isEmptyObject(s.$control)){s.$control.on('click',this[stname].bind(this));}}
this.transitionTo_('initial');};allControllers[contEl.id]=new PlaylistController(contEl,options_);return allControllers[contEl.id];};return PlaylistControllers;});
