<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */

namespace Avreg\Playlist;

class M3U
{
    protected $eol;
    private $header = '';
    private $body = '';
    
    public function __construct($options = false, $meta = false)
    {
        $this->eol = "\r\n"; // windows compatible style

        if ($options && is_array($options)) {
            if (isset($options['eol'])) {
                $this->eol = $options['eol'];
            }
        }

        $this->appendLine($this->header, '#EXTM3U');
    }

    protected function appendLine(&$var, $str)
    {
        $var .= $str . $this->eol;
    }

    public function addTrack($trackInfo)
    {
        $title = date('Y-m-d_H:i:s', $trackInfo['date']) . ' - ' . $trackInfo['title'];
        $this->appendLine($this->body, "#EXTINF:$trackInfo[duration], $title");
        $this->appendLine($this->body, $trackInfo['location']);
    }

    public function gen()
    {
        return $this->header . $this->body;
    }
}

/* vim: set expandtab smartindent tabstop=4 shiftwidth=4: */
