<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
/**
 * @file offline/playlist.php
 * @brief Архив : плейлист
 */
$USE_SESSION = true;
$pageTitle = 'PlaylistTitle';
$pageBgColor = '#D0DCE0';
$lang_file = '_offline.php';
$USE_JQUERY = true;
$link_javascripts = array(
    'lib/js/checkbox.js',
    'lib/js/third-party/jquery.qtip.js',
    'lib/js/persist-forms.js',
    'offline/playlist/js/playlist.js'
);
$css_links = array(
    'lib/css/third-party/jquery.qtip.min.css',
    'offline/playlist/css/playlist.css'
);
require '../head.inc.php';
require '../lib/get_cams_params.inc.php';
require_once '../lib/html-inputs-helper.php';

$jsDictKeys = [
    'playlistFormValidationErrors',
    'htmlTimeSlicesModeHelp',
    'strAdvices',
    'strClose',
    'strDisclose'
];

echo("<script>\n");
print "var MESSAGES = [];\n";
foreach ($jsDictKeys as &$m) {
    printf(
        "MESSAGES['%s'] = %s;\n",
        $m,
        json_encode(
            $$m,
            JSON_NUMERIC_CHECK | JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE
        )
    );
}
echo("\n</script>");

DENY($arch_status);
$recordable_cams = get_recordable_cameras(true);

if (!count($recordable_cams)) {
    print '<p><b>' . $strNotCamsDef2 . '</b></p>' . "\n";
    print "<p><a href=\"$conf[prefix]/\" target=\"_parent\">$strToMainPage</a></p>\n";
    require '../foot.inc.php';
    exit;
}

// tohtml($recordable_cams);

if (!isset($year1) || !isset($year2)) {
    $tm2 = localtime(time(), true);
    $tm1 = localtime(strtotime('-1 hours'), true);
    $year1 = $tm1['tm_year'] + 1900;
    $month1 = $tm1['tm_mon'];
    $day1 = array_search($tm1['tm_mday'], $day_array);
    $hour1 = array_search($tm1['tm_hour'], $hour_array);
    $year2 = $tm2['tm_year'] + 1900;
    $month2 = $tm2['tm_mon'];
    $day2 = array_search($tm2['tm_mday'], $day_array);
    $hour2 = array_search($tm2['tm_hour'], $hour_array);

    $minute_ar_values = array_values($minute_array);
    $minute1 = $minute_ar_values[0];
    $minute2 = end($minute_array);
}

if (isset($_SESSION) && isset($_SESSION['error']) /* ошибка */) {

    if ($_SESSION['error'] == '0') {
        /* нет данных */
        echo "<div id=\"server-alert\" class=\"warn\">\n";
        echo "<h3>$strNoEvents</h3>\n";
        if ($conf['debug'] && !empty($_SESSION['sql'])) {
            echo $_SESSION['sql'];
        }
    } else {
        echo "<div class=\"error\">\n";
        echo 'error: invalid field(s) &quot;' . $_SESSION['error'] . "&quot;\n";
    }
    echo "</div>\n";

    unset($_SESSION['error']);
}
?>

<div id="js-alert">
</div>

<form id='get-playlist-query' action="<?php echo $conf['prefix']; ?>/lib/playlist.php" method="POST">
    <fieldset>
        <legend><?php echo $left_tune; ?></legend>
        <table cellspacing="0" border="0" cellpadding="5">
            <tr valign="top">
                <td style="width:300px;">
                    <?php
                        //формируем список чекбоксов выбора камер
                        print getChkbxByArray(
                            'cams',
                            $recordable_cams,
                            array_keys($recordable_cams),
                            array(
                                'limitInputs' => 8
                            )
                        );
                    ?>
                </td>
                <td>
                    <fieldset id="id_content_type">
                        <legend><?php echo $strFTypeTitle; ?></legend>
                        <label>
                            <input id="chk_video" type="checkbox" checked name="ftypes[]" value="23">
                            <?php echo $env_id_ar[23]; ?>
                        </label>
                        <br>
                        <label>
                            <input id="chk_audio" type="checkbox" checked name="ftypes[]" value="32">
                            <?php echo $env_id_ar[32]; ?>
                        </label>
                    </fieldset>
                </td>
            </tr>
        </table>
    </fieldset>
    <br>
    <fieldset>
        <legend><?php echo $strTimeRangeSelect; ?></legend>
        <table cellspacing="0" border="0" cellpadding="5">
            <?php print '<tr bgcolor="' . $header_color . '">' . "\n"; ?>
            <?php
            print '<th class="query" valign="bottom">' . $strTimeMode .
                '&nbsp;<a id="time-slices-mode-help"><sup>help</sup></a></th>' . "\n";
            ?>
            <th class="query" valign="bottom"><?php echo "$strYear / $strMonth / $strDay"; ?></th>
            <th class="query" valign="bottom"><?php echo $strDayOfWeek; ?></th>
            <th class="query" valign="bottom"><?php echo "$strHour:$strMinute"; ?></th>
            </tr>
            <tr align="center" valign="top">
                <td align="left">
                    <br>
                    <label>
                        <input id="time-slices-mode" name="time-slices-mode" type="checkbox" value="1">
                        <?php echo $strIntervals; ?>
                    </label>
                </td>
                <td align="left" nowrap>
                    <?php
                    print "$sFromDate<br />\n";
                    print getSelectByAssocAr('year1', $year_array, false, 1, 0, $year1, false, false);
                    print getSelectHtml('month1', $month_array, false, 1, 1, $month_array[$month1], false, false);
                    print getSelectHtml('day1', $day_array, false, 1, 1, $day_array[$day1], false, false);
                    print "<br /><br />$sToDate<br />\n";
                    print getSelectByAssocAr('year2', $year_array, false, 1, 0, $year2, false, false);
                    print getSelectHtml('month2', $month_array, false, 1, 1, $month_array[$month2], false, false);
                    print getSelectHtml('day2', $day_array, false, 1, 1, $day_array[$day2], false, false);
                    ?>
                </td>
                <td align="center" style="width:150px;">
                    <?php
                    print getChkbxByArray('weekdays', $day_of_week, '0,1,2,3,4,5,6');
                    ?>
                </td>
                <td align="left" nowrap>
                    <?php
                    print "$sFromTime<br />\n";
                    print getSelectHtml('hour1', $hour_array, false, 1, 0, $hour_array[$hour1], false, false);
                    print getSelectByAssocAr('minute1', $minute_array, false, 1, 0, $minute1, false, false);
                    print "<br /><br />$sToTime<br />\n";
                    print getSelectHtml('hour2', $hour_array, false, 1, 0, $hour_array[$hour2], false, false);
                    print getSelectByAssocAr('minute2', $minute_array, false, 1, 0, $minute2, false, false);
                    ?>
                </td>
            </tr>
        </table>
    </fieldset>
    <br>
    <fieldset>
        <legend><?php echo $strPlFmtTitle; ?></legend>
        <label>
            <input type="radio" name="pl_fmt" checked value="M3U">
            <?php echo $strM3U; ?>
        </label>
        <br>
        <label>
            <input type="radio" name="pl_fmt" value="XSPF">
            <?php echo $strXSPF; ?>
        </label>
        <br>
        <label>
            <input type="radio" name="pl_fmt" value="TXT">
            <?php echo $strTXT; ?>
        </label>
        <br>
        <?php echo $strLinesEnding ?>
        <label><input type="radio" checked name="lineending" value="AUTO"> Auto</label>
        &nbsp;&nbsp;
        <label><input type="radio" name="lineending" value="CRLF"> Windows</label>
        &nbsp;&nbsp;
        <label><input type="radio" name="lineending" value="CR"> Unix</label>
    </fieldset>
    <br>
    <fieldset>
        <input type="submit" id="btnSubmit"
            data-enabled-label="<?php echo $GetPlaylistStr; ?>"
            data-disabled-label="<?php echo $strWait; ?>"
            value="<?php echo $GetPlaylistStr; ?>">
        &nbsp;&nbsp;
        <input type="reset" id="btnReset" value="<?php echo $strReset; ?>">
        &nbsp;&nbsp;
        <a href="<?php echo $conf['prefix']; ?>/"
           target="_parent"><?php echo $strToMainPage; ?></a>
    </fieldset>
</form>

<div class="help">
    <legend class="tip-spoiler-title" title="<?php echo $strDisclose; ?>">
    <?php echo $strAdvices; ?> +
    </legend>
    <div id="tip-spoiler-body">
        <ul>
            <li><?php echo $strBrowserHandlers; ?></li>
            <li><?php echo $strPlaylistOpenHelp; ?></li>
            <li><?php echo $strMassCopy; ?></li>
       </ul>
    </div>
</div>

<?php
require '../foot.inc.php';

