<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
/**
 * @file offline/search.php
 */

$USE_SESSION=true;
$USE_JQUERY = true;
$USE_BOOTSTRAP = true;
$USE_VIDEOJS = true;
$IE_COMPAT='IE=Edge';
$ie6_quirks_mode = true;
$body_style = '';
$lang_file = '_offline.php';
$css_links = array(
    'lib/css/third-party/bootstrap/daterangepicker.css',
    'lib/css/third-party/bootstrap/bs.timepicker.css',
    'offline/search/css/search.css'
);
$DISABLE_MAIN_CSS = true;

$link_javascripts = array(
    'lib/js/dl.js',
    'lib/js/nozoomresize.js',
    'lib/js/playlist-controller.js',
    'lib/js/persist-forms.js',
    'lib/js/third-party/jquery-check-all.js',
    'lib/js/third-party/filesize.js',
    'lib/js/third-party/moment-with-locales.js',
    'lib/js/third-party/bootstrap/daterangepicker.js',
    'lib/js/third-party/bootstrap/bs.timepicker.js',
    'lib/js/third-party/sprintf.js',
    'lib/js/third-party/interact.js',
    'offline/search/js/media-toolbar.js',
    'offline/search/js/show-event.js',
    'offline/search/js/search.js'
);

require '../head.inc.php';
require '../lib/get_cams_params.inc.php';
require '../lib/gen-controls.inc.php';
$__JS_VAR__ = true;
require '../lib/get-cam-urls.php';

DENY($arch_status);

$allCams_params = get_cams_params('work, text_left');
$allCams = array();
foreach ($allCams_params as $camNr => $value) {
    if ($camNr > 0) {
        $allCams[$camNr] = getCamName($value['text_left']['v']);
    }
}
$recordable_cams = get_recordable_cameras();

if (empty($allCams)) {
    print '<div class="container"><div class="alert alert-warning" style="font-size: 200%;" role="alert">';
    print '<div>' . $strNotCamsDef2 . "</div>\n";
    print_go_back();
    print '</div></div>' . "\n";
    require('../foot.inc.php');
    exit;
}
?>

<script>
<?php
print 'var CAMS = ' .
    json_encode($allCams, JSON_NUMERIC_CHECK | JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE) . ";\n";
print 'var AVREG_EVENTS = ' .
    json_encode($env_id_ar, JSON_NUMERIC_CHECK | JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE) . ";\n";

$jsMsgs = [
    'strNoEventsLeft',
    'strNoEventsRight',
    'strNoEvents',
    'strToday',
    'strYesterday',
    'strThisWeek',
    'strLastWeek',
    'strThisMonth',
    'strLastMonth',
    'strOK',
    'strRevoke',
    'strFrom',
    'strTo',
    'strCustomChoice',
    'playlistFormValidationErrors',
    'fmtDownloadPrompt',
    'fmtDownloadZipTooLarge',
    'strMessage',
    'strDownload',
    'strOpen',
    'htmlTimeSlicesModeHelp'
];
print "var MESSAGES = [];\n";
foreach ($jsMsgs as &$m) {
    printf(
        "MESSAGES['%s'] = %s;\n",
        $m,
        json_encode(
            $$m,
            JSON_NUMERIC_CHECK | JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE
        )
    );
}
?>
</script>
<div class="top-toolbar text-right">
    <div class="btn-group" role="group" aria-label="...">
        <button id='help-btn' type="button" class="btn btn-default glyphicon glyphicon-question-sign active" title="<?php echo $strHelp; ?>">
        </button><button
            type="button" class="btn btn-default glyphicon glyphicon-wrench"
            data-toggle="modal" data-target="#settings"
            title="<?php echo $strSettings; ?>"
        ></button>
        <a href="../" class="btn btn-default glyphicon glyphicon-home"
        role="button" title="<?php echo $strToMainPage; ?>"></a>
    </div>
</div>

<header class="container-fluid">
    <form id="search-query" method="POST">
<?php
    require 'search/template/query.inc.php';
?>
    </form>
</header>

<div id="middle-row">
    <div id="sidebar">
        <div id="playlist-container" class="frame events-toolbar-top">
<?php
    require 'search/template/playlist-toolbar.inc.php';
?>
        </div>
        <div class="frame" id="events">
            <table id="events-table" class="table table-stripped table-hover">
                <tbody id="events-table-body">
                </tbody>
            </table>
        </div>
        <div class="frame events-toolbar-bottom">
            <div class="container-fluid">
                <div id="events-paginator" class="row">
<?php
    require 'search/template/events-paginator.inc.php';
?>
                </div>
                <div id="download-toolbar" class="row" style="display: none">
<?php
    require 'search/template/download-toolbar.inc.php';
?>
                </div>
            </div>
        </div>
    </div>

    <div id="vdivider">
    </div>

    <div id="content">
        <div id="content-body">
<?php
    require 'search/template/view.inc.php';
?>
        </div>
        <div class="frame" id="content-toolbar">
            <div class="container-fluid">
                <div class="row">
<?php
    require 'search/template/content-toolbar.inc.php';
?>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
    require 'search/template/settings.inc.php';
?>

<div class="loading-spinner"></div>

<?php
require '../foot.inc.php';
