<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
/**
 *
 * @file offline/template/query.inc.php
 * @brief HTML темплейт формы запроса
 */

// defaults
$filter_sel = '23,32,16,3,1,17,15,12';

$maxRowsPerPageArray = array(100, 300, 500);
$maxRowsPerPageDef = $maxRowsPerPageArray[1];

$playbackRates = array('0.1x', '0.2x', '0.5x', '1x', '2x', '3x', '5x', '10x');
$playbackRate = '1x';
$slowMotionPlaybackRate = '0.2x';

$playlistAfterMediaEndTimeouts = array(1,2,3,4,5);
$playlistAfterMediaEndTimeout = 2;

$playlistTextDurations = array(2,3,4,5,6,7);
$playlistTextDuration = 4;

$reqCams = request_int_array('cams');
?>

<div class="row">
    <div class="col-md-5 col-sm-4">
        <div class="opt-group-header">
            <div class="checkbox">
                <label><input id="opt-cams-check-all" type="checkbox"><?php echo $left_tune; ?> (</label>
                <label><input id="opt-cams-only-recordable" type="checkbox" checked>recordable )</label>
            </div>
        </div>
        <div class="opt-group-content" id="opt-cams-container">
<?php
foreach ($allCams as $camNr => $camName) {
    if ($reqCams) {
        $checked = in_array($camNr, $reqCams);
    } else {
        $checked = true;
    }

    echo('<div class="checkbox">' . "\n");
    printf(
        "<label><input type=\"checkbox\" name=\"cams[]\" value=\"%d\" data-recordable=\"%d\" %s>%s</label>\n",
        $camNr,
        (int)array_key_exists($camNr, $recordable_cams),
        $checked ? 'checked' : '',
        shortCamName($camNr, $camName)
    );
    echo("</div>\n");
}
?>
        </div>
    </div>
    <div class="col-md-4 col-sm-4">
        <div class="opt-group-header">
            <div class="checkbox">
                <label class="checkbox-inline">
                    <input id="opt-weekdays-check-all" type="checkbox">
                    <?php echo $strAll; ?>
                </label>
            </div>
        </div>
        <div class="opt-group-content">
            <fieldset id="opt-weekdays-container" title="<?php echo $htmlTimeSlicesModeHelp2; ?>">
<?php
$i = 0;
foreach ($day_of_week as &$dayShort) {
    printf(
        "<label class=\"checkbox-inline\">" .
        "<input type=\"checkbox\" name=\"weekdays[]\" value=\"%d\" checked>%s" .
        "</label>\n",
        $i,
        $dayShort
    );
    $i += 1;
}
?>
            </fieldset>
            <input id="date-range" type="text" class="form-control" name="date-range"
                placeholder='<?php echo "$strFromToDateRange"; ?>'>
        </div>
    </div>
    <div class="col-md-3 col-sm-4">
        <div class="opt-group-header">
            <div class="checkbox">
                <label>
                    <input id="time-slices-mode" name="time-slices-mode" type="checkbox" value="1">
                    <?php echo $strIntervals; ?>
                </label>
                <a id="time-slices-help" class="icon help" title="<?php echo $strTip; ?>">
                    <i class="glyphicon glyphicon-question-sign"></i>
                </a>
            </div>
        </div>
        <div class="opt-group-content">
            <div class="input-group bootstrap-timepicker timepicker">
                <span class="input-group-addon text-right"><i><?php echo $strFrom; ?>:</i></span>
                <input id="time-from" name="time-from" type="text" class="form-control input-small"
                    placeholder='<?php echo "$strHour:$strMinute"; ?>'>
            </div>
            <div class="input-group bootstrap-timepicker timepicker">
                <span class="input-group-addon text-right"><i><?php echo $strTo; ?>:</i></span>
                <input id="time-to" name="time-to" type="text" class="form-control input-small"
                    placeholder='<?php echo "$strHour:$strMinute"; ?>'>
            </div>
        </div>
    </div>
    <div class="col-md-4 col-sm-4">
        <div class="opt-group-header">
            <div class="checkbox">
                <label><input id="opt-events-check-all" type="checkbox"><?php echo $strEvents; ?> (</label>
                <label><input id="opt-events-only-media" type="checkbox" checked>media )</label>
            </div>
        </div>
        <div class="opt-group-content" id="opt-events-container">
<?php
foreach ($env_id_ar as $evtId => $evtName) {
    echo('<div class="checkbox">' . "\n");
    printf(
        "<label><input type=\"checkbox\" name=\"events[]\" value=\"%d\" checked>%s</label>\n",
        $evtId,
        $evtName
    );
    echo("</div>\n");
}
?>
        </div>
    </div>
    <div class="col-md-2 col-sm-4">
        <div class="opt-group-header">
        </div>
        <div class="opt-group-content">
            <input type="hidden" id="offset" name="offset">
            <br>
            <button type="submit" class="btn btn-default"><?php echo $strGet; ?></button>
            <button type="reset" class="btn btn-default"><?php echo $strReset; ?></button>
        </div>
    </div>
</div>
