<?php
/**
 * Copyright (C) 2004-2021 "Setevye informacionnye sistemy", Ltd (Russia)
 *                          en: "Network Information Systems"
 */
/**
 *
 * @file offline/search/template/settings.inc.php
 * @brief HTML template of settings modal form
 */

?>

<!-- Modal -->
<div class="modal fade" id="settings" tabindex="-1" role="dialog" aria-labelledby="settingsLabel">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
        <h4 class="modal-title"><?php echo $tune_logo; ?></h4>
      </div>
      <div class="modal-body">
        <form id="search-settings" class="form-horizontal">
            <h4><?php echo $strEmbedPlayerSettingsHeader; ?></h4>
            <div class="form-group">
                <div class="col-sm-4 text-right">
                    <input id="embed-media" type="checkbox" checked
                            name="embed-media"
                            title="<?php echo $str_embed_Title; ?>">
                </div>
                <label for="embed-media" class="col-sm-14 text-lowercase"><?php echo $strEmbdedVideo; ?></label>
            </div>
            <div class="form-group">
                <div class="col-sm-4">
<?php
                print genSelectHtml(
                    $playbackRates,
                    $playbackRate,
                    false,
                    array(
                        'id' => 'playback-rate',
                        'name' => 'playback-rate',
                        'class' => 'form-control'
                    )
                );
?>
                </div>
                <label for="playback-rate" class="col-sm-14 text-lowercase">
                    <?php echo $strPlaybackRates; ?>
                </label>
            </div>
            <div class="form-group">
                <div class="col-sm-4">
<?php
                print genSelectHtml(
                    $playbackRates,
                    $slowMotionPlaybackRate,
                    false,
                    array(
                        'id' => 'playback-rate-slow-motion',
                        'name' => 'playback-rate-slow-motion',
                        'class' => 'form-control'
                    )
                );
?>
                </div>
                <label for="playback-rate" class="col-sm-14">
                    <?php echo $strSlowMotionPlaybackRates; ?>
                </label>
            </div>


            <h4 class='hr-before' ><?php echo $strPlaylistSettingsHeader; ?></h4>

            <div class="form-group">
                <div class="col-sm-4">
<?php
                print genSelectHtml(
                    $maxRowsPerPageArray,
                    $maxRowsPerPageDef,
                    false,
                    array(
                        'id' => 'rows-per-page',
                        'name' => 'limit',
                        'class' => 'form-control'
                    )
                );
?>
                </div>
                <label for="playback-rate" class="col-sm-14 text-lowercase">
                    <?php echo $str_row_maxTitle; ?>
                </label>
            </div>
            <div class="form-group">
                <div class="col-sm-4">
<?php
                print genSelectHtml(
                    $playlistAfterMediaEndTimeouts,
                    $playlistAfterMediaEndTimeout,
                    false,
                    array(
                        'id' => 'pl-after-media-end-timeout',
                        'name' => 'pl-after-media-end-timeout',
                        'class' => 'form-control',
                        'title' => 'in seconds'
                    )
                );
?>
                </div>
                <label class="col-sm-14 text-lowercase">
                    <?php echo $strPlaylistAfterMediaEndPause; ?>
                </label>
             </div>
             <div class="form-group">
                <div class="col-sm-4">
<?php
                print genSelectHtml(
                    $playlistTextDurations,
                    $playlistTextDuration,
                    false,
                    array(
                        'id' => 'pl-text-duration',
                        'name' => 'pl-text-duration',
                        'class' => 'form-control',
                        'title' => 'in seconds'
                    )
                );
?>
                </div>
                <label class="col-sm-14 text-lowercase">
                    <?php echo $strPlaylistTextDuration; ?>
                </label>
            </div>
       </form>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal"><?php echo $strClose; ?></button>
        <button type="button" class="btn btn-primary" id="save-settings"><?php echo $strSave; ?></button>
      </div>
    </div>
  </div>
</div>

